/*  agent3.h */

#ifndef __AGENT_H__
#define __AGENT_H__

#include "stype.h"
#include "atype.h"
#include "inmorph.h"
#include "keyword.h"
#include "numstack.h"

#define DEFAULT_HP		15	// Ǥγư
#define AGENT_MYSTACK_SIZE	100	// HP * 2 * 3
#define AGENT_CNT_MEMORY_SIZE	10	// bwjall ǤϹ⡹ cnt8 ޤǻ
#define AGENT_LOC_MEMORY_SIZE	5	// bwjall Ǥ $3 ޤǻ

// ==================================================================
// ȥޥ͡

typedef struct {
  int name;		// Ȥ̾ʿɡˡʥ˥ѡ
  int parent;		// ƥ
  AgentAge age;		// CHILD/ADULT
  AgentMode mode;	// FULLMODE, HALFMODE, SLEEPMODE
  unsigned char hp;	// 1Ǥ̿
  LocType loc_type; 	// LOC_NODE/LOC_ARC
  int loc_idx;		// Ρɤ䥢ؤΥǥ
  int depth;		// ֥ͥåȥο (1 ᥤѥΥͥåȥ)
  int rfrd_syn;		// ؿθоݤηǥǥ
  int rfrd_sem;		// ̣°оݤηǥǥ
  int prfrd_syn;	// pop ȤΥͥåȥ˰Ѥ rfrd_syn 
  int prfrd_sem;	// pop ȤΥͥåȥ˰Ѥ rfrd_sem 

  int mystack[AGENT_MYSTACK_SIZE]; // ֥ͥåѥå
  int mysp;			   // 嵭Υåݥ
  int cnt_memory[AGENT_CNT_MEMORY_SIZE]; // 󥿵ꥢ
  int loc_memory[AGENT_LOC_MEMORY_SIZE]; // $͵ꥢ
  int awake_time;	// active ˤʤ

  int mypivot;		// ơ֥Υǥ
} Agent;


typedef struct {
  Agent *list;	// ޥ͡㤬Ƥ륨ȤΥꥹ
  int *table;
  int max;	// Ǥ
  int pivot;	// ȥꥹȤλѲǽʥǥͤκǾ

  SType *smap;	// SΥޥå
  AType *amap;  // AΥޥåסʥѥ󡢤ӡѿ
  AType *pmap;	// ѥΥޥå

  int num_of_pattern; // 0 ֤ num_of_patternĤʸѥ󡣤ʹߤA

  InMorph   *im;	// ʸ
  EucAllMap imbitmap;   // ʸɬܻ̾ȹ礹뤿Υӥåȥޥå

  NumStack *actlist; // ư楨ȥꥹ
  NumStack *slplist; // ٷ楨ȥꥹ
  NumStack *tmplist; // 򥨡ȥꥹ
  NumStack *angellist; // ʸѥ˥ޥåȥꥹ
  int last_name; // ȤȯԿʥ˥ѡ
} AgentManager;


// ==================================================================
// ȴ
AgentManager *agent_manager_open(int); // ȯ­ȿ
void agent_manager_clear(AgentManager *);	 // ƤΥꥢ
void agent_manager_close(AgentManager *);	 // 
void agent_manager_dump(AgentManager *, FILE *); // ˥

// Ϣ
// ޥåפϢȡϷǤϢ
#define agent_manager_map(_am,_st,_at) ((_am)->smap=(_st),(_am)->amap=(_at))
#define agent_manager_morph(_am,_im) ((_am)->im=(_im))

// ==================================================================
// ȸ̤
// ˥
void agent_print(AgentManager *, int, FILE *);
void agent_print_detail(AgentManager *, int, FILE *);
void agent_manager_test(AgentManager *);

// ȯȾ
//  ʤΥ꡼ϡѤΤǡȤϥǥ
//    ϤȤ
int agent_new(AgentManager *);		// ȯ
int agent_breed(AgentManager *, int);	// Ҷ򻺤
void agent_growup(AgentManager *, int); // ͤˤʤ
void agent_kill(AgentManager *, int);	// 


// ư
#define agent_move_to_node(_agt,_idx) ((_agt)->loc_type=LOC_NODE,(_agt)->loc_idx = (_idx))
#define agent_move_to_arc(_agt,_idx) ((_agt)->loc_type=LOC_ARC,(_agt)->loc_idx=(_idx))
#define agent_downto(_agt) ((_agt)->depth += 1)
#define agent_upto(_agt) ((_agt)->depth -= 1)


// 
// -----  -----
// #define agent_push(_agt,_num) ((_agt)->mystack[(_agt)->mysp++]=(_num))
// #define agent_pop(_agt) ((_agt)->mystack[--(_agt)->mysp])
void agent_push(Agent *, int);
int agent_pop(Agent *);

// -----  -----
void agent_increase_counter( Agent *, int);
int agent_compare_counter( Agent *, int, int, CmpType);

// ----- ֵε -----
#define agent_store_location_mark(_agt,_loc,_num)\
	(_agt->loc_memory[(_loc)]=(_num))

// ----- ȹ̡δϢ -----
void agent_store_local_result(AgentManager *, Agent *, int);
void agent_store_global_result(AgentManager *, Agent *, int, int);

#endif
