/*
 * asmemory.c
 * 2005.7/8 by tokuhisa
 *
 * ʸ򡢥ͤȤϥå塣
 * ʸΰ롣
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "st.h"
#include "error.h"
#include "asmemory.h"

AsMemory *asmemory_new(int sz1, int sz2)
{
  AsMemory *asom;

  if( (asom = (AsMemory *)malloc(sizeof(AsMemory))) == NULL )
    error(MALLOC_FAILED,"asmemory_new 1");
  
  if( (asom->block = (char *)malloc(sizeof(char) * sz1)) == NULL )
    error(MALLOC_FAILED,"asmemory_new 2");
  asom->b_max = sz1;
  
  if( (asom->strlink = (AsLink *)malloc(sizeof(AsLink) * sz2)) == NULL )
    error(MALLOC_FAILED,"asmemory_new 3");
  asom->l_max = sz2;
  
  asom->st = st_init_strtable();
  
  asom->b_free = 0;
  asom->l_free = 0;

  return asom;
}



void asmemory_dump(AsMemory *asom, FILE *fp)
{
  int i;

  fprintf(fp,"block(%d/%d)\n", asom->b_free, asom->b_max );
  for( i = 0; i < asom->b_free; i += 1 )
    if( asom->block[i] == '\0' )
      fprintf(fp,"\\0");
    else
      fprintf(fp,"%c",asom->block[i]);
  fprintf(fp,"\n");

  fprintf(fp,"IDX: str-link(%d/%d)\n", asom->l_free, asom->l_max );
  for( i = 0; i < asom->l_free; i += 1 )
    fprintf(fp,"%d: %s  %s\n",i,asom->strlink[i].str,asom->strlink[i].link);
  fprintf(fp,"\n");
}



int as_set(AsMemory *asom, char *key, char *value)
{
  st_data_t tmp;
  int idx, len;
  char *p;

  if( st_lookup(asom->st, (st_data_t)key, &tmp) ){
    idx = (int)tmp;
  } else {
    len = strlen(key);
    if( len + asom->b_free + 1 >= asom->b_max )
      error(OVER_FLOWED, "asmemory_set 1");
    if( asom->l_free == asom->l_max )
      error(OVER_FLOWED, "asmemory_set 2");
    p = &asom->block[asom->b_free];
    strcpy(p, key);
    asom->b_free += len + 1;
    idx = asom->l_free++;
    asom->strlink[idx].str = p;
    st_insert(asom->st, (st_data_t)p, (st_data_t)idx);
  }

  len = strlen(value);
  if( len + asom->b_free + 1 >= asom->b_max )
    error(OVER_FLOWED, "asmemory_set 1");
  p = &asom->block[asom->b_free];
  strcpy(p, value);
  asom->b_free += len + 1;
  asom->strlink[idx].link = p;
  return idx;
}



char *as_get(AsMemory *asom, char *key)
{
  st_data_t tmp;

  if( st_lookup(asom->st, (st_data_t)key, &tmp) )
    return asom->strlink[(int)tmp].link;
  return NULL;
}
