/*
 * atype.c		A
 *						2005.6/18 by tokuhisa
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define __ATYPE_C__
#include "atype.h"

#include "string_bank.h"
#include "scanner.h"
#include "error.h"
#include "eucmap.h"

// ===================================================================
// ѤΥꥢ

#define MAX_SORTER_STR	1000	// 1ʸ
#define MAX_SORTER_ARCS	10000	// 1ѥ󤢤Υ


// -------------------------------------------------------------------
// 

typedef struct {
  char str[MAX_SORTER_STR];
  int key;
  int next;
} ListNode;

typedef struct {
  ListNode *nodes;
  int max;
  int free;
} List;

// ==================================================================
// ɬܻ

EucAllMap      impbitmap;

void pickup_importantwords(AType *a, char *inputline, int *idx, int *num)
{
  char *p, *q;
  int len;

  p = inputline;
  while( *p != ';' ){
    if( *p == '\0' )
      return;
    p += 1;
  }
  p += 1;

  while( *p != '{' ){
    if( *p == '\0' )
      return;
    p += 1;
  }
  p += 1;

  q = p;
  len = 0;
  while( *p != '}' ){
    if( *p == '\0' )
      return;
    p += 1;
    len += 1;
  }
  // q λؤȤ len ХȤɬܻ
  eucmap_bitmap_clear( impbitmap );
  eucmap_create_bitmap( q, len, impbitmap );
  eucmap_set_bitmap( impbitmap, a->epb, idx, num );
}



// ====================================================================
// -------------------------------------------------------------------
// ν


void cnd_bank_open(AType *a, int size)
{
  a->cb = (CndBank *)malloc(sizeof(CndBank));
  if( a->cb == NULL )
    error(MALLOC_FAILED,"cnd_bank_new1");
  
  a->cb->cnd = (Cnd *)malloc(sizeof(Cnd) * size);
  if( a->cb->cnd == NULL )
    error(MALLOC_FAILED,"cnd_bank_new2");
    
  a->cb->max = size;
  a->cb->free = 0;
}


void cnd_bank_clear(AType *a)
{
  a->cb->free = 0;
}


void cnd_bank_close(AType *a)
{
  free(a->cb->cnd);
  free(a->cb);
  a->cb = NULL;
}


int cnd_bank_add(AType *a, Sign sflag, char *cndline)
{
  int len, t1,t2;

  if( a->cb->free >= a->cb->max )
    error(OVER_FLOWED,"cnd_bank_add");

  a->cb->cnd[a->cb->free].sign = sflag;

  if( sscanf(cndline,"cnt%d==%d",&t1,&t2) == 2 ){
    a->cb->cnd[a->cb->free].ctype = CNT;
    a->cb->cnd[a->cb->free].num1 = t1;
    a->cb->cnd[a->cb->free].cmp = EQ;
    a->cb->cnd[a->cb->free].num2 = t2;
    return a->cb->free++;
  }

  if( sscanf(cndline,"cnt%d!=%d",&t1,&t2) == 2 ){
    a->cb->cnd[a->cb->free].ctype = CNT;
    a->cb->cnd[a->cb->free].num1 = t1;
    a->cb->cnd[a->cb->free].cmp = NE;
    a->cb->cnd[a->cb->free].num2 = t2;
    return a->cb->free++;
  }

  if( strcmp(cndline,"jump") == 0 ){
    a->cb->cnd[a->cb->free].ctype = JUMP;
    return a->cb->free++;
  }

  if( strcmp(cndline,"phi") == 0 ){
    a->cb->cnd[a->cb->free].ctype = PHI;
    return a->cb->free++;
  }

  if( strcmp(cndline,"pop") == 0 ){
    a->cb->cnd[a->cb->free].ctype = POP;
    return a->cb->free++;
  }

  if( strcmp(cndline,"+") == 0 ){
    a->cb->cnd[a->cb->free].ctype = BCAT;
    return a->cb->free++;
  }

  if( strcmp(cndline,"!") == 0 ){
    a->cb->cnd[a->cb->free].ctype = BCUT;
    return a->cb->free++;
  }

  if( strcmp(cndline,"^setmark(*)") == 0 ){
    a->cb->cnd[a->cb->free].ctype = SMK;
    a->cb->cnd[a->cb->free].ref = SEM;
    return a->cb->free++;
  }

  if( strcmp(cndline,"^setmark(^)") == 0 ){
    a->cb->cnd[a->cb->free].ctype = SMK;
    a->cb->cnd[a->cb->free].ref = SYN;
    return a->cb->free++;
  }
  
  if( (strcmp(cndline,"^setmark(*^)") == 0 ) ||
      (strcmp(cndline,"^setmark(^*)") == 0 ) ) {
    a->cb->cnd[a->cb->free].ctype = SMK;
    a->cb->cnd[a->cb->free].ref = BOTH;
    return a->cb->free++;
  }

  if( (len = scan_EUCS(cndline,0)) > 0 ){
    a->cb->cnd[a->cb->free].ctype = RAW;
    a->cb->cnd[a->cb->free].word = string_bank_add(a->sb, cndline);
    a->cb->cnd[a->cb->free].len = len;
    return a->cb->free++;
  }

  if( (t1 = scan_SQ(cndline,0)) > 0 )
    if( (len = scan_EUCS(cndline,t1)) > 0 )
      if( (t2 = scan_SQ(cndline,t1+len)) > 0 ){
	a->cb->cnd[a->cb->free].ctype = STD;
	a->cb->cnd[a->cb->free].word = string_bank_add_n(a->sb, &cndline[t1], len);
	a->cb->cnd[a->cb->free].len = len;
	return a->cb->free++;
      }

  if( (t1 = scan_LALPHAS(cndline,0)) > 0 ){
    a->cb->cnd[a->cb->free].ctype = VAR;
    a->cb->cnd[a->cb->free].str = string_bank_add_n(a->sb, cndline, t1);
    if( (t2 = scan_NUMS(cndline,t1)) > 0 )
      a->cb->cnd[a->cb->free].num = atoi(&cndline[t1]);
    else
      a->cb->cnd[a->cb->free].num = -1;
    return a->cb->free++;
  }

  if( (t1 = scan_DOT(cndline,0)) > 0 ){
    if( (t2 = scan_SHARP(cndline,t1)) > 0 )
      t1 += t2;
    if( (t2 = scan_SALPHAS(cndline,t1)) > 0 ){
      t1 += t2;
      a->cb->cnd[a->cb->free].ctype = VAR;
      a->cb->cnd[a->cb->free].str = string_bank_add_n(a->sb, cndline, t1);
      if( (t2 = scan_NUMS(cndline,t1)) > 0 )
	a->cb->cnd[a->cb->free].num = atoi(&cndline[t1]);
      else
	a->cb->cnd[a->cb->free].num = -1;
      return a->cb->free++;
    }
  }

  if( (t1 = scan_HAT(cndline,0)) > 0 )
    if( (t2 = scan_SALPHAS(cndline,t1)) > 0 ){
      a->cb->cnd[a->cb->free].ctype = FSY;
      a->cb->cnd[a->cb->free].str = string_bank_add_n(a->sb, cndline, t1+t2);
      return a->cb->free++;
    }

  if( (t1 = scan_SLASH(cndline,0)) > 0 ){
    if( (t2 = scan_SALPHAS(cndline,t1)) > 0 ){
      a->cb->cnd[a->cb->free].ctype = RSN;
      a->cb->cnd[a->cb->free].str = string_bank_add_n(a->sb, cndline, t1+t2);
      return a->cb->free++;
    } else {
      a->cb->cnd[a->cb->free].ctype = RSN;
      a->cb->cnd[a->cb->free].str = string_bank_add_n(a->sb, cndline, t1);
      return a->cb->free++;
    }
  }

  error(SYNTAX_ERROR,cndline);
  exit(1);
}


void cnd_bank_print_one(AType *a, int i, FILE *fp)
{
  switch( a->cb->cnd[i].ctype ){
  case RAW:
    fprintf(fp,"c%d:[RAW, %c, %s(%d)]\n", i, (a->cb->cnd[i].sign == NEG ? '-' : '+'), string_bank_ref(a->sb, a->cb->cnd[i].word), a->cb->cnd[i].len);
    break;
  case STD:
    fprintf(fp,"c%d:[STD, %c, '%s']\n", i, (a->cb->cnd[i].sign == NEG ? '-' : '+'), string_bank_ref(a->sb, a->cb->cnd[i].word));
    break;
  case VAR:
    fprintf(fp,"c%d:[VAR, %c, %s, %d]\n", i, (a->cb->cnd[i].sign == NEG ? '-' : '+'), string_bank_ref(a->sb, a->cb->cnd[i].str), a->cb->cnd[i].num);
    break;
  case VARS:
    fprintf(fp,"c%d:[VARS, %c, %s%d  p%d]\n", i, (a->cb->cnd[i].sign == NEG ? '-' : '+'), string_bank_ref(a->sb, a->cb->cnd[i].str), a->cb->cnd[i].num, a->cb->cnd[i].link);
    break;
  case VARA:
    fprintf(fp,"c%d:[VARA, %c, %s%d  n%d]\n", i, (a->cb->cnd[i].sign == NEG ? '-' : '+'), string_bank_ref(a->sb, a->cb->cnd[i].str), a->cb->cnd[i].num, a->cb->cnd[i].link);
    break;
  case FSY:
    fprintf(fp,"c%d:[FSY, %c, %s  p%d]\n", i, (a->cb->cnd[i].sign == NEG ? '-' : '+'), string_bank_ref(a->sb, a->cb->cnd[i].str), a->cb->cnd[i].link);
    break;
  case RSN:
    fprintf(fp,"c%d:[RSN, %c, %s  p%d]\n", i, (a->cb->cnd[i].sign == NEG ? '-' : '+'), string_bank_ref(a->sb, a->cb->cnd[i].str), a->cb->cnd[i].link);
    break;
  case CNT:
    if( a->cb->cnd[i].cmp == EQ )
      fprintf(fp,"c%d:[CNT, %c, cnt%d==%d]\n", i, (a->cb->cnd[i].sign == NEG ? '-' : '+'), a->cb->cnd[i].num1, a->cb->cnd[i].num2);
    else
      fprintf(fp,"c%d:[CNT, %c, cnt%d!=%d]\n", i, (a->cb->cnd[i].sign == NEG ? '-' : '+'), a->cb->cnd[i].num1, a->cb->cnd[i].num2);
    break;
  case JUMP:
    fprintf(fp,"c%d:[JUMP, jump]\n", i);
    break;
  case PHI:
    fprintf(fp,"c%d:[PHI, phi]\n", i);
    break;
  case POP:
    fprintf(fp,"c%d:[POP, pop]\n", i);
    break;
  case BCAT:
    fprintf(fp,"c%d:[BCAT, %c, +]\n", i, (a->cb->cnd[i].sign == NEG ? '-' : '+'));
    break;
  case BCUT:
    fprintf(fp,"c%d:[BCUT, %c, !]\n", i, (a->cb->cnd[i].sign == NEG ? '-' : '+'));
    break;
  case SMK:
    switch( a->cb->cnd[i].ref ){
    case NONE:
      break;
    case SEM:
      fprintf(fp,"c%d:[SMK, ^setmark(*)]\n", i);
      break;
    case SYN:
      fprintf(fp,"c%d:[SMK, ^setmark(^)]\n", i);
      break;
    case BOTH:
      fprintf(fp,"c%d:[SMK, ^setmark(*^)]\n", i);
      break;
    }
    break;
  }
}



void cnd_bank_dump(AType *a, FILE *fp)
{
  int i;

  fprintf(fp,"CndBank(max = %d)\n", a->cb->max);
  for( i = 0; i < a->cb->free ; i += 1 )
    cnd_bank_print_one(a,i,fp);
}


void cnd_bank_save(AType *a, FILE *fp)
{
  fprintf(fp, "%d %d\n", a->cb->max, a->cb->free);
  fwrite(a->cb->cnd, sizeof(Cnd), a->cb->free, fp);
}


void cnd_bank_load(AType *a, FILE *fp)
{
  if( a->cb != NULL )
    cnd_bank_close(a);

  a->cb = (CndBank *)malloc(sizeof(CndBank));
  if( a->cb == NULL )
    error(MALLOC_FAILED,"cnd_bank_load 1");

  // -------------------- إå --------------------
  fscanf(fp,"%d %d\n", &a->cb->max, &a->cb->free);


  a->cb->cnd = (Cnd *)malloc(sizeof(Cnd) * a->cb->max);
  if( a->cb->cnd == NULL )
    error(MALLOC_FAILED,"cnd_bank_load 2");

  // -------------------- ܥǥ --------------------
  fread(a->cb->cnd, sizeof(Cnd), a->cb->free, fp);
}


void cnd_bank_strip(AType *a)
{
  a->cb->max = a->cb->free + 1;
}


// -------------------------------------------------------------------
// γǼ

void net_memory_bank_open(AType *a, int size)
{
  a->nmb = (NetMemoryBank *)malloc(sizeof(NetMemoryBank));
  if( a->nmb == NULL )
    error(MALLOC_FAILED,"net_memory_bank_new 1\n");
  a->nmb->memory = (NetMemory*)malloc(sizeof(NetMemory) * size);
  if( a->nmb->memory == NULL )
    error(MALLOC_FAILED,"net_memory_bank_new 2\n");
  a->nmb->max = size;
  a->nmb->free = 0;
}


void net_memory_bank_clear(AType *a)
{
  a->nmb->free = 1;
}


void net_memory_bank_close(AType *a)
{
  free(a->nmb->memory);
  free(a->nmb);
  a->nmb = NULL;
}


void net_memory_bank_dump(AType *, FILE *);

int net_memory_bank_add(AType *a, char *mem)
{
  int t1, t2;

  if( mem[0] == '\0' )
    return 0;

  if( sscanf(mem,"#%d",&t1) == 1 ){
    if( a->nmb->free >= a->nmb->max )
      error(OVER_FLOWED,"net_memory_bank_add 1\n");
    a->nmb->memory[a->nmb->free].type = SMEM;
    a->nmb->memory[a->nmb->free].num = t1;
    return a->nmb->free++;
  }

  if( sscanf(mem,"cnt%d++",&t1) == 1 ){
    if( a->nmb->free >= a->nmb->max ){
      net_memory_bank_dump(a, stdout);
      error(OVER_FLOWED,"net_memory_bank_add 2\n");
    }
    a->nmb->memory[a->nmb->free].type = CMEM;
    a->nmb->memory[a->nmb->free].num = t1;
    return a->nmb->free++;
  }

  if( sscanf(mem, "$%d=%d", &t1, &t2) == 2 ){
    if( a->nmb->free >= a->nmb->max )
      error(OVER_FLOWED,"net_memory_bank_add 3\n");
    a->nmb->memory[a->nmb->free].type = LOC;
    a->nmb->memory[a->nmb->free].loc = t1;
    a->nmb->memory[a->nmb->free].offset = t2;
    return a->nmb->free++;
  }

  error(SYNTAX_ERROR,"mem");
  exit(1);
}


void net_memory_bank_dump(AType *a, FILE *fp)
{
  int i;

  fprintf(fp,"NetMemoryBank(max = %d)\n",a->nmb->max);
  fprintf(fp,"m0:[--------]\n");
  for( i = 1; i < a->nmb->free ; i += 1 ){
    switch( a->nmb->memory[i].type ){
    case SMEM:
      fprintf(fp,"m%d:[ #%d     ]\n",i, a->nmb->memory[i].num );
      break;
    case CMEM:
      fprintf(fp,"m%d:[ cnt%d++ ]\n",i, a->nmb->memory[i].num );
      break;
    case LOC:
      fprintf(fp,"m%d:[ $%d = %d]\n",i, a->nmb->memory[i].loc,a->nmb->memory[i].offset);
      break;
    }
  }
}


void net_memory_bank_save(AType *a, FILE *fp)
{
  fprintf(fp, "%d %d\n", a->nmb->max, a->nmb->free);
  fwrite(a->nmb->memory, sizeof(NetMemory), a->nmb->free, fp);
}


void net_memory_bank_load(AType *a, FILE *fp)
{
  if( a->nmb != NULL )
    net_memory_bank_close(a);

  a->nmb = (NetMemoryBank *)malloc(sizeof(NetMemoryBank));
  if(a->nmb == NULL )
    error(MALLOC_FAILED,"net_memroy_bank_load 1");

  fscanf(fp, "%d %d\n", &a->nmb->max, &a->nmb->free);

  a->nmb->memory = (NetMemory *)malloc(sizeof(NetMemory) * a->nmb->max);
  if( a->nmb->memory == NULL )
    error(MALLOC_FAILED,"net_memory_bank_load 2");

  fread(a->nmb->memory, sizeof(NetMemory), a->nmb->free, fp);
}


void net_memory_bank_strip(AType *a)
{
  a->nmb->max = a->nmb->free + 1;
}




// -------------------------------------------------------------------
// ϥΡɤν

void begin_node_bank_open(AType *a, int size)
{
  a->bnb = (BgnNodeBank *)malloc(sizeof(BgnNodeBank));
  if( a->bnb == NULL )
    error(MALLOC_FAILED,"begin_node_bank_new 1");
  a->bnb->bgnode = (BgnNode *)malloc(sizeof(BgnNode)*size);
  if( a->bnb->bgnode == NULL )
    error(MALLOC_FAILED,"begin_node_bank_new 2");
  a->bnb->max = size;
  a->bnb->free = 0;
}


void begin_node_bank_clear(AType *a)
{
  a->bnb->free = 0;
}


void begin_node_bank_close(AType *a)
{
  free(a->bnb->bgnode);
  free(a->bnb);
  a->bnb = NULL;
}


void begin_node_bank_dump(AType *a, FILE *fp)
{
  int i;

  fprintf(fp,"BgnNodeBank(max = %d)\n",a->bnb->max);
  for( i = 0; i < a->bnb->free; i += 1 )
    fprintf(fp,"b%d:[a%d,%d]\n",i,a->bnb->bgnode[i].index_of_arc,a->bnb->bgnode[i].num);
}


void begin_node_bank_save(AType *a, FILE *fp)
{
  fprintf(fp,"%d %d\n", a->bnb->max, a->bnb->free);
  fwrite(a->bnb->bgnode, sizeof(BgnNode), a->bnb->free, fp);
}



void begin_node_bank_load(AType *a, FILE *fp)
{
  if( a->bnb != NULL )
    begin_node_bank_close(a);

  a->bnb = (BgnNodeBank *)malloc(sizeof(BgnNodeBank));
  if( a->bnb == NULL )
    error(MALLOC_FAILED,"begin_node_bank_load 1");

  fscanf(fp, "%d %d\n", &a->bnb->max, &a->bnb->free);

  a->bnb->bgnode = (BgnNode *)malloc(sizeof(BgnNode) * a->bnb->max);
  if( a->bnb->bgnode == NULL )
    error(MALLOC_FAILED,"begin_node_bank_load 2");

  fread(a->bnb->bgnode, sizeof(BgnNode), a->bnb->free, fp);
}



void begin_node_bank_strip(AType *a)
{
  a->bnb->max = a->bnb->free + 1;
}



// -------------------------------------------------------------------
// ν

void arc_bank_open(AType *a, int size)
{
  a->ab = (ArcBank *)malloc(sizeof(ArcBank));
  if( a->ab == NULL )
    error(MALLOC_FAILED,"arc_bank_new 1");
  a->ab->arc = (Arc *)malloc(sizeof(Arc) * size);
  if( a->ab->arc == NULL )
    error(MALLOC_FAILED,"arc_bank_new 2");
  a->ab->max = size;
  a->ab->free = 0;
}



void arc_bank_clear(AType *a)
{
  a->ab->free = 0;
}


void arc_bank_close(AType *a)
{
  free(a->ab->arc);
  free(a->ab);
  a->ab = NULL;
}



RefType scan_ref(char *ref)
{
  switch( ref[0] ){
  case '\0':
    return NONE;
  case '*':
    switch( ref[1] ){
    case '\0':
      return SEM;
    case '^':
      return BOTH;
    }
    break;
  case '^':
    switch( ref[1] ){
    case '\0':
      return SYN;
    case '*':
      return BOTH;
    }
    break;
  }
  error(SYNTAX_ERROR,ref);
  exit(1);
}



void arc_bank_add(AType *a, int base, int n1, int n2, char *cnd, char *ref, char *mem)
{
  int idx_bnb, idx_ab;
  Sign sflag;

  idx_bnb = base + n1 - 1;
  if( idx_bnb == a->bnb->free ){
    if( a->bnb->free == a->bnb->max )
      error(OVER_FLOWED,"arc_bank_add 1\n");
    a->bnb->bgnode[a->bnb->free].index_of_arc = a->ab->free;
    a->bnb->bgnode[a->bnb->free].num = 0;
    a->bnb->free += 1;
  }


  if( a->ab->free == a->ab->max)
    error(OVER_FLOWED,"arc_bank_add 2\n");
  a->ab->free += 1;

  a->bnb->bgnode[idx_bnb].num += 1;
  idx_ab = a->bnb->bgnode[idx_bnb].index_of_arc + a->bnb->bgnode[idx_bnb].num - 1;
  if( n2 == 0 )
    a->ab->arc[idx_ab].ed = 0;
  else
    a->ab->arc[idx_ab].ed = base + n2 - 1;
  if( cnd[0] == '-' ) {
    sflag = NEG;
    cnd += 1;
  } else
    sflag = POS;
  a->ab->arc[idx_ab].cnd = cnd_bank_add(a, sflag, cnd);
  a->ab->arc[idx_ab].ref = scan_ref(ref);
  a->ab->arc[idx_ab].mem = net_memory_bank_add(a,mem);
}



void arc_bank_dump(AType *a, FILE *fp)
{
  int i;

  fprintf(fp,"ArcBank(max = %d)\n",a->ab->max);
  for(i = 0; i < a->ab->free; i += 1 ){
    if( a->ab->arc[i].ed == 0 )
      fprintf(fp,"a%d:[--,c%d,",i,a->ab->arc[i].cnd);
    else
      fprintf(fp,"a%d:[b%d,c%d,",i,a->ab->arc[i].ed,a->ab->arc[i].cnd);
    switch( a->ab->arc[i].ref ){
    case NONE:
      fprintf(fp,"  ");
      break;
    case SEM:
      fprintf(fp,"* ");
      break;
    case SYN:
      fprintf(fp,"^ ");
      break;
    case BOTH:
      fprintf(fp,"*^");
      break;
    }
    fprintf(fp,",m%d]\n",a->ab->arc[i].mem);
  }
}


void arc_bank_save(AType *a, FILE *fp)
{
  fprintf(fp, "%d %d\n", a->ab->max, a->ab->free);
  fwrite(a->ab->arc, sizeof(Arc), a->ab->free, fp);
}



void arc_bank_load(AType *a, FILE *fp)
{
  if( a->ab != NULL )
    arc_bank_close(a);

  a->ab = (ArcBank *)malloc(sizeof(ArcBank));
  if( a->ab == NULL )
    error(MALLOC_FAILED,"arc_bank_load 1");

  fscanf(fp,"%d %d\n", &a->ab->max, &a->ab->free);

  a->ab->arc = (Arc *)malloc(sizeof(Arc) * a->ab->max);
  if( a->ab->arc == NULL )
    error(MALLOC_FAILED,"arc_bank_load 2");

  fread(a->ab->arc, sizeof(Arc), a->ab->free, fp);
}



void arc_bank_strip(AType *a)
{
  a->ab->max = a->ab->free + 1;
}



// -------------------------------------------------------------------
// ͥåȥν

void network_bank_open(AType *a, int size)
{
  a->nb = (NetworkBank *)malloc(sizeof(NetworkBank));
  if( a->nb == NULL )
    error(MALLOC_FAILED,"network_bank_new 1");
  a->nb->network = (Network *)malloc(sizeof(Network) * size);
  if( a->nb->network == NULL )
    error(MALLOC_FAILED,"network_bank_new 2");
  a->nb->max = size;
  a->nb->free = 0;
}


void network_bank_clear(AType *a)
{
  a->nb->free = 0;
}


void network_bank_close(AType *a)
{
  free(a->nb->network);
  free(a->nb);
  a->nb = NULL;
}


int network_bank_new_pattern(AType *a, char *pname, int idx, int num)
{
  Network *n;

  if( a->nb->free == a->nb->max )
    error(OVER_FLOWED,"network_bank_new_pattern");
  n = &a->nb->network[a->nb->free];
  n->name = string_bank_add(a->sb,pname);
  n->start_node = a->bnb->free;
  n->letter_condition = idx;
  n->lc_num = num;
  a->nb->free += 1;
  return a->bnb->free;
}


void network_bank_dump(AType *a, FILE *fp)
{
  int i;

  fprintf(fp,"NetworkBank(max = %d)\n",a->nb->max);
  for( i = 0; i < a->nb->free ; i += 1 )
    fprintf(fp,"n%d:[%s,b%d]\n",i,string_bank_ref(a->sb,a->nb->network[i].name),a->nb->network[i].start_node);
}



void network_bank_save(AType *a, FILE *fp)
{
  fprintf(fp, "%d %d\n", a->nb->max, a->nb->free);
  fwrite(a->nb->network, sizeof(Network), a->nb->free, fp);
}


void network_bank_load(AType *a, FILE *fp)
{
  if( a->nb != NULL )
    network_bank_close(a);

  a->nb = (NetworkBank *)malloc(sizeof(NetworkBank));
  if( a->nb == NULL )
    error(MALLOC_FAILED,"network_bank_load 1");

  fscanf(fp,"%d %d\n", &a->nb->max, &a->nb->free);

  a->nb->network = (Network *)malloc(sizeof(Network) * a->nb->max);
  if( a->nb->network == NULL )
    error(MALLOC_FAILED,"network_bank_load 2");

  fread(a->nb->network, sizeof(Network), a->nb->free, fp);
}


void network_bank_strip(AType *a)
{
  a->nb->max = a->nb->free + 1;
}



// ===================================================================
// arc եιԤΥ

// ȡԡκ
void comcut_chomp_spccut(char *line)
{
  int i,j;
  char *p;

  // Ȥ
  for( i = 0; line[i] != ';' && line[i] != '\n' && line[i] != '\0' ; i += 1 ){}
  line[i] = '\0';
  for( i -= 1; i > 0 && (line[i] == '\t' || line[i] == ' ') ; i -= 1 ) {}
  i += 1;
  line[i] = '\0';

  // ڡκ
  for( p = line, j = 0; j < i; j += 1 ){
    if( line[j] != ' ' && line[j] != '\t' )
      *p++ = line[j];
  }
  *p = '\0';
}


// arc Υ
char *scan_arc(char *line, int *n1, int *n2, char *cnd, char *ref, char *mem)
{
  char *p;

  p = strstr(line,"arc(");
  p += 4;  // a,r,c,( 򥹥å
  *n1 = 0;
  while( '0' <= *p && *p <= '9' )	// Ρ
    *n1 = *n1 * 10 + *p++ - '0';
  p += 1;  // ޤ򥹥å
  *n2 = 0;
  while( '0' <= *p && *p <= '9' )	// Ρ
    *n2 = *n2 * 10 + *p++ - '0';
  p += 1;  // ޤ򥹥å

  while( *p != ',' && *p != ')' ){	// 
    if( *p == '(' )
      while( *p != ')' )
	*cnd++ = *p++;
    *cnd++ = *p++;
  }
  *cnd = '\0';

  if( *p == ',' ){			// ͭС
    p += 1;
    while( *p != ',' && *p != ')' )
      *ref++ = *p++;
  }
  *ref = '\0';
  if( *p == ',' ){			// ͭС
    p += 1;
    while( *p != ')' )
      *mem++ = *p++;
  }
  *mem = '\0';

  return p+1;
}



// -------------------------------------------------------------------
// Υ, ꥹȡ󥵡ȥ

void list_clear(List *lst)
{
  int i;

  lst->nodes[0].next = 0;

  for( i = 1 ; i < lst->max ; i += 1 )
    lst->nodes[i].next = i + 1;
  lst->nodes[i-1].next = 0;
  lst->free = 1;
}



List *list_new(int size)
{
  List *ans;

  ans = (List *)malloc(sizeof(List));
  if( ans == NULL ){
    fprintf(stderr,"arc_sorter malloc failed(1).\n");
    exit(1);
  }

  ans->max = size;
  ans->nodes = (ListNode *)malloc(sizeof(ListNode) * ans->max);
  if( ans->nodes == NULL ){
    fprintf(stderr,"arc_sorter malloc failed(2).\n");
    exit(1);
  }

  list_clear(ans);

  return ans;
}



void list_insert(List *lst, char *str, int key)
{
  int p, x;

  p = 0;
  if( lst->free == 0 ){
    fprintf(stderr,"error over flowed\n");
    exit(1);
  }

  while( 1 ){
    if( lst->nodes[p].next == 0 || lst->nodes[lst->nodes[p].next].key > key ){
      x = lst->free;
      lst->free = lst->nodes[lst->free].next;
      lst->nodes[x].next = lst->nodes[p].next;
      lst->nodes[p].next = x;

      strcpy(lst->nodes[x].str, str);
      lst->nodes[x].key = key;
      break;
    }
    p = lst->nodes[p].next;
  }
}


char *list_pop(List *lst)
{
  int t;
  char *ans;

  if( lst->nodes[0].next == 0 )
    return NULL;

  t = lst->nodes[0].next;
  ans = lst->nodes[t].str;
  lst->nodes[0].next = lst->nodes[t].next;
  lst->nodes[t].next = lst->free;
  lst->free = t;
  return ans;
}



// ===================================================================
// ͥåȥǼ

AType *atype_open(int nets, int nodes, int arcs, int mems, int cnds, int bts)
{
  AType *a;

  a = (AType *)malloc(sizeof(AType));
  if( a == NULL )
    error(MALLOC_FAILED,"atype_open");
  network_bank_open(a,nets);
  begin_node_bank_open(a,nodes);
  arc_bank_open(a,arcs);
  net_memory_bank_open(a,mems);
  cnd_bank_open(a,cnds);
  a->epb = eucmap_bank_open(bts);

  return a;
}


// -------------------------------------------------------------------
// ͥåȥƤƾõʥ곫ʤ
void atype_clear(AType *a)
{
  network_bank_clear(a);
  begin_node_bank_clear(a);
  arc_bank_clear(a);
  net_memory_bank_clear(a);
  cnd_bank_clear(a);
  eucmap_bank_clear(a->epb);
}


// -------------------------------------------------------------------
// ͥåȥĤʥ곫
void atype_close(AType *a)
{
  network_bank_close(a);
  begin_node_bank_close(a);
  arc_bank_close(a);
  net_memory_bank_close(a);
  cnd_bank_close(a);
  eucmap_bank_close(a->epb);
  free(a);
}


// -------------------------------------------------------------------
// Aե뤫ͥåȥɤ롣

#define LINE_LENGTH 10000

void atype_convert(AType *a, FILE *fp)
{
  char s[LINE_LENGTH];
  char cnd[100], ref[100], mem[100], *t;
  int n1, n2, base;
  enum {NAME,ARC} mode;
  List *sorter;
  char *arc, *p, q;
  int bgnode;
  int impidx, impnum; // ɬܻ̤ΥӥåȥޥåפǼȸĿ

  sorter = list_new(MAX_SORTER_ARCS);

  base = 0;
  mode = NAME;
  while( fgets(s,LINE_LENGTH,fp) != NULL ){
    pickup_importantwords(a,s,&impidx,&impnum); // ɬܻѤν
    comcut_chomp_spccut(s); // ȡʸ;ʬʥڡΥå
    if( s[0] == '\0' )
      continue;

    switch(mode){
    case NAME:
      base = network_bank_new_pattern(a, s, impidx, impnum);
      mode = ARC;
      break;
    case ARC:
      if( strcmp("end",s) != 0 ){
	t = s;
	while( (t = strstr(t,"arc(")) != NULL ){
	  sscanf(t,"arc(%d,", &bgnode);
	  p = t + 4;
	  while( *p != ')' ){
	    if( *p == '(' )
	      while( *p++ != ')' ){}
	    p += 1;
	  }
	  p += 1;
	  q = *p;
	  *p = '\0';
	  list_insert(sorter, t, bgnode);
	  *p = q;
	  t = p;
	}
      } else {
	while( (arc = list_pop(sorter)) != NULL ){
	  scan_arc(arc, &n1, &n2, cnd, ref, mem);
	  arc_bank_add(a, base, n1, n2, cnd, ref, mem);
	}
	mode = NAME;
      }
      break;
    }
  }
}



// -------------------------------------------------------------------
// ƤΥ
void atype_dump(AType *a, FILE *fp)
{
  network_bank_dump(a,fp);
  begin_node_bank_dump(a,fp);
  arc_bank_dump(a,fp);
  net_memory_bank_dump(a,fp);
  cnd_bank_dump(a,fp);
  string_bank_dump(a->sb,fp);
  eucmap_bank_dump(a->epb,fp);
}


// -------------------------------------------------------------------
// ꥤ᡼ե˽

void atype_save(AType *a, FILE *fp)
{
  network_bank_save(a,fp);
  begin_node_bank_save(a,fp);
  arc_bank_save(a,fp);
  net_memory_bank_save(a,fp);
  cnd_bank_save(a,fp);
  string_bank_save(a->sb, fp);
  eucmap_bank_save(a->epb, fp);
}


// -------------------------------------------------------------------
// ե뤫ꥤ᡼

AType *atype_load(FILE *fp)
{
  AType *a;

  a = (AType *)malloc(sizeof(AType));
  if( a == NULL )
    error(MALLOC_FAILED,"atype_load");
  network_bank_load(a,fp);
  begin_node_bank_load(a,fp);
  arc_bank_load(a,fp);
  net_memory_bank_load(a,fp);
  cnd_bank_load(a,fp);
  a->sb = string_bank_load(fp);
  a->epb = eucmap_bank_load(fp);

  return a;
}


// -------------------------------------------------------------------
// Max Ǿ¤ˤ

void atype_strip(AType *a)
{
  network_bank_strip(a);
  begin_node_bank_strip(a);
  arc_bank_strip(a);
  net_memory_bank_strip(a);
  cnd_bank_strip(a);
  eucmap_bank_strip(a->epb);
}



// ===================================================================
// dst θ src 򤯤äĤ

int atype_cat_atype(AType *dst, AType *src)
{
  int offst_cb, offst_nmb, offst_bnb, offst_ab, offst_nb, offst_epb;
  int i, sz, idx;

  offst_cb = dst->cb->free;
  offst_nmb = dst->nmb->free;
  offst_bnb = dst->bnb->free;
  offst_ab = dst->ab->free;
  offst_nb = dst->nb->free;
  offst_epb = dst->epb->free;

  sz = src->nb->free;
  for( i = 0 ; i < sz ; i += 1 ){
    if( dst->nb->free >= dst->nb->max )
      error(OVER_FLOWED,"atype_cat_atype 1");
    idx = dst->nb->free++;
    dst->nb->network[idx].name =
      string_bank_add(dst->sb,
		      string_bank_ref(src->sb,src->nb->network[i].name));
    dst->nb->network[idx].start_node =
      src->nb->network[i].start_node + offst_bnb;

    dst->nb->network[idx].letter_condition =
      src->nb->network[i].letter_condition + offst_epb;
    dst->nb->network[idx].lc_num =
      src->nb->network[i].lc_num + offst_epb;
  }

  sz = src->ab->free;
  for( i = 0; i < sz; i += 1 ){
    if( dst->ab->free >= dst->ab->max )
      error(OVER_FLOWED,"atype_cat_atype 2");
    idx = dst->ab->free++;
    if( src->ab->arc[i].ed != 0 )
      dst->ab->arc[idx].ed = src->ab->arc[i].ed + offst_bnb;
    else
      dst->ab->arc[idx].ed = 0;
    dst->ab->arc[idx].cnd = src->ab->arc[i].cnd + offst_cb;
    dst->ab->arc[idx].ref = src->ab->arc[i].ref;
    dst->ab->arc[idx].mem = src->ab->arc[i].mem + offst_nmb;
  }

  sz = src->bnb->free;
  for( i = 0; i < sz; i += 1 ){
    if( dst->bnb->free >= dst->bnb->max )
      error(OVER_FLOWED,"atype_cat_atype 3");
    idx = dst->bnb->free++;
    dst->bnb->bgnode[idx].index_of_arc =
      src->bnb->bgnode[i].index_of_arc + offst_ab;
    dst->bnb->bgnode[idx].num = src->bnb->bgnode[i].num;
  }

  sz = src->nmb->free;
  for( i = 0 ; i < sz; i += 1 ){
    if( dst->nmb->free >= dst->nmb->max )
      error(OVER_FLOWED,"atype_cat_atype 4");
    idx = dst->nmb->free++;
    dst->nmb->memory[idx].type = src->nmb->memory[i].type;
    dst->nmb->memory[idx].num = src->nmb->memory[i].num;
  }

  sz = src->cb->free;
  for( i = 0; i < sz; i += 1 ){
    if( dst->cb->free >= dst->cb->max )
      error(OVER_FLOWED,"atype_cat_atype 5");
    idx = dst->cb->free++;
    switch( dst->cb->cnd[idx].ctype = src->cb->cnd[i].ctype ){
    case RAW:
    case STD:
      dst->cb->cnd[idx].word =
	string_bank_add(dst->sb,
			string_bank_ref(src->sb, src->cb->cnd[i].word));
      dst->cb->cnd[idx].len = src->cb->cnd[i].len;
      break;
    case VAR:
    case FSY:
    case RSN:
      dst->cb->cnd[idx].str =
	string_bank_add(dst->sb,
			string_bank_ref(src->sb, src->cb->cnd[i].str));
      dst->cb->cnd[idx].num = src->cb->cnd[i].num;
      break;
    case CNT:
      dst->cb->cnd[idx].num1 = src->cb->cnd[i].num1;
      dst->cb->cnd[idx].cmp  = src->cb->cnd[i].cmp;
      dst->cb->cnd[idx].num2 = src->cb->cnd[i].num2;
      break;
    case SMK:
      dst->cb->cnd[idx].ref = src->cb->cnd[i].ref;
      break;
    case VARS:  // иʤϥ
    case VARA:  // иʤϥ
      error(UNKNOWN,"atype_cat_atype");
      break;
    case JUMP:
    case PHI:
    case POP:
    case BCAT:
    case BCUT:
      // ctypeʳˤϲ⥳ԡʤ
      break;
    }
  }
	 
  sz = src->epb->free;
  for( i = 0; i < sz; i += 1 ){
    if( dst->epb->free >= dst->epb->max )
      error(OVER_FLOWED,"atype_cat_atype 6");
    idx = dst->epb->free++;
    dst->epb->pmap[idx].index = src->epb->pmap[i].index;
    dst->epb->pmap[idx].pmap = src->epb->pmap[i].pmap;
  }

  return offst_nb;
}
