/*
 * core_check.c
 * åΥ֥롼ʸ˥饤֥경
 *
 * 2005.7/5 by tokuhisa
 */

#include "agent.h"
#include "error.h"
#include "inmorph.h"
#include "agent.h"
#include "cnd_checker.h"
#include "core_checker.h"


// ==================================================================

int across_arc(AgentManager *am, int agt_idx, int ref, int arc_idx)
{
  Agent *agt;
  Arc   *arc;
  Cnd   *cnd;
  int cnd_idx, rslt;
  NetMemory *mem;

  agt = agent_pointer( am, agt_idx );
  arc = arc_pointer( am, arc_idx );
  cnd_idx = arc->cnd;
  cnd = cnd_pointer( am, cnd_idx );


  agt->hp -= 1;
  if( agt->hp == 0 ){
    agt->mode = HELLMODE;
    return 0;
  }

  // ==================================================================
  // θ

  // cnd->ctype Ȥ˽򤹤
  // fullmode & halfmode :  JUMP,PHI, CNT, SMK, FSY, FSM, VARA, POP,
  // fullmode only       :  BCAT,BCUTŬ塢mode ϥס
  // fullmode only       :  RAW, STD, VARS

  switch( cnd->ctype ){
  // ------------------------------------------------------------------
  // Ǥ񤷤ʤ
  case JUMP:
    agent_growup( am, agt_idx );
    agent_move_to_node( agt, arc->ed );
#ifdef _TEST_HIT_
    printf(">  jump\n");
#endif
    break;

  case PHI:
    agent_growup( am, agt_idx );
    agent_move_to_node( agt, arc->ed );
    agent_store_global_result( am, agt, cnd_idx, 0 );
#ifdef _TEST_HIT_
    printf(">  phi\n");
#endif
    break;

  case CNT:
    if( agent_compare_counter( agent_pointer(am, agt->parent), cnd->num1, cnd->num2, cnd->cmp ) ){
      agent_growup( am, agt_idx );
      agent_move_to_node( agt, arc->ed );
#ifdef _TEST_HIT_
      printf(">  match cnt%d%s%d\n", cnd->num1, cnd->cmp == EQ ? "==" : "!=", cnd->num2);
#endif
    } else {
      agt->mode = HELLMODE;
#ifdef _TEST_HIT_
      printf(">  unmatch (cnt%d%s%d)\n", cnd->num1, cnd->cmp == EQ ? "==" : "!=", cnd->num2);
#endif
      return 0;
    }
    break;

  case SMK:
    agent_growup( am, agt_idx );
    switch( cnd->ref ){
    case NONE:
      break;
    case SEM:
      agt->prfrd_sem = agt->rfrd_sem;
#ifdef _TEST_HIT_
      printf(">  setmark(*)\n");
#endif
      break;
    case SYN:
      agt->prfrd_syn = agt->rfrd_syn;
#ifdef _TEST_HIT_
      printf(">  setmark(^)\n");
#endif
      break;
    case BOTH:
      agt->prfrd_sem = agt->rfrd_sem;
      agt->prfrd_syn = agt->rfrd_syn;
#ifdef _TEST_HIT_
      printf(">  setmark(*^)\n");
#endif
      break;
    }
    agent_move_to_node( agt, arc->ed );
    break;

  case FSY:
    if( (cnd_check_preterm( am->im, agt->rfrd_syn, am->smap, cnd->link, &rslt ) & 0x2) == 0 ){
      agt->mode = HELLMODE;
#ifdef _TEST_HIT_
      printf(">  unmatch (%s)\n",string_bank_ref(am->amap->sb,cnd->str));
#endif
      return 0;
    } else {
      agent_growup( am, agt_idx );
      agent_move_to_node( agt, arc->ed );
      if( inmorph_same_morph_line( am->im, agt->rfrd_syn, agt->rfrd_sem ) ){
	agt->rfrd_syn = rslt;
	agt->rfrd_sem = rslt;
      } else {
	agt->rfrd_syn = rslt;
      }
#ifdef _TEST_HIT_
      printf(">  match %s\n",string_bank_ref(am->amap->sb,cnd->str));
#endif
    }
    break;

    /*
  case FSM: //ߤϥߡ
    agent_growup( am, agt_idx );
    agent_move_to_node( agt, arc->ed );
    break;
    */

  case RSN:
  case VARA:
    agent_growup( am, agt_idx );
    agent_push( agt, arc_idx );
    agent_downto( agt );
    agent_move_to_node( agt, pattern_first_node(am, cnd->link) );
    agent_push( agt, agt->prfrd_syn );
    agent_push( agt, agt->prfrd_sem );
    agt->prfrd_syn = agt->rfrd_syn;
    agt->prfrd_sem = agt->rfrd_sem;
#ifdef _TEST_HIT_
    printf(">  go to %s\n", string_bank_ref(am->amap->sb,cnd->str) );
#endif
    break;

  case POP:
    agent_growup( am, agt_idx );
    agent_upto( agt );
    if( agt->depth > 0 ){

      agt->rfrd_syn = agt->prfrd_syn;
      agt->rfrd_sem = agt->prfrd_sem;
      agt->prfrd_sem = agent_pop( agt );
      agt->prfrd_syn = agent_pop( agt );

      arc_idx = agent_pop( agt );
      arc = arc_pointer( am, arc_idx );
      agent_move_to_node( agt, arc->ed );
      cnd_idx = arc->cnd;
      cnd = cnd_pointer( am, cnd_idx );
#ifdef _TEST_HIT_
      printf(">  pop from %s\n", string_bank_ref(am->amap->sb,cnd->str));
#endif
      if( agt->depth == 1 && agt->mode == HALFMODE ) // join Τ
	agt->mode = SLEEPMODE; // join Τ
    } else{
      agt->mode = HEAVENMODE;
#ifdef _TEST_HIT_
      printf(">  fin                                        !!!\n");
#endif
    }
    break;

  // ------------------------------------------------------------------
  // Ǥ񤷤ʤfullmode ưʤ
  // ä

  case BCAT:
    if( agt->mode == HALFMODE ){
      if( (cnd_check_border( am->im, ref+1, '+' ) & 0x2) != 0 ){
	agent_growup( am, agt_idx );
	agent_move_to_node( agt, arc->ed );
#ifdef _TEST_HIT_
	printf(">  match +\n");
#endif
      } else {
	agt->mode = HELLMODE;
#ifdef _TEST_HIT_
	printf(">  unmatch (+)\n");
#endif
	return 0;
      }
      /*
      agent_growup( am, agt_idx );
      agent_move_to_arc( agt, arc_idx );
      agt->mode = SLEEPMODE;
#ifdef _TEST_HIT_
      printf(">  sleep BCAT (%s)\n",string_bank_ref(am->amap->sb, cnd->word));
#endif
      */
    } else { // ACTIVEMODE
      if( (cnd_check_border( am->im, ref, '+' ) & 0x2) != 0 ){
	agent_growup( am, agt_idx );
	agent_move_to_node( agt, arc->ed );
#ifdef _TEST_HIT_
	printf(">  match +\n");
#endif
      } else {
	agt->mode = HELLMODE;
#ifdef _TEST_HIT_
	printf(">  unmatch (+)\n");
#endif
	return 0;
      }
    }
    break;

  case BCUT:
    if( agt->mode == HALFMODE ){
      if( (cnd_check_border( am->im, ref+1, '/' ) & 0x2) != 0 ){
	agent_growup( am, agt_idx );
	agent_move_to_node( agt, arc->ed );
#ifdef _TEST_HIT_
	printf(">  match !\n");
#endif
      } else {
	agt->mode = HELLMODE;
#ifdef _TEST_HIT_
	printf(">  unmatch (!)\n");
#endif
	return 0;
      }
      /*
      agent_growup( am, agt_idx );
      agent_move_to_arc( agt, arc_idx );
      agt->mode = SLEEPMODE;
#ifdef _TEST_HIT_
      printf(">  sleep BCUT (%s)\n",string_bank_ref(am->amap->sb, cnd->word));
#endif
      */
    } else { // ACTIVEMODE
      if( (cnd_check_border( am->im, ref, '/' ) & 0x2) != 0 ){
	agent_growup( am, agt_idx );
	agent_move_to_node( agt, arc->ed );
#ifdef _TEST_HIT_
	printf(">  match !\n");
#endif
      } else {
	agt->mode = HELLMODE;
#ifdef _TEST_HIT_
	printf(">  unmatch (!)\n");
#endif
	return 0;
      }
    }
    break;

  // ------------------------------------------------------------------
  // Ǥ񤹤륿

  case RAW:
    if( agt->mode == HALFMODE ){
      agent_growup( am, agt_idx );
      agent_move_to_arc( agt, arc_idx );
      agt->mode = SLEEPMODE;
#ifdef _TEST_HIT_
      printf(">  sleep raw (%s)\n",string_bank_ref(am->amap->sb, cnd->word));
#endif
    } else { // ACTIVEMODE
      if( ( cnd_check_raw( am->im,
			   ref,
			   string_bank_ref(am->amap->sb, cnd->word),
			   cnd->len,
			   &rslt ) &0x2 ) != 0 ){
	agent_growup( am, agt_idx );
	agent_move_to_node( agt, arc->ed );
	agt->rfrd_syn = rslt;
	agt->rfrd_sem = rslt;
	agt->mode = HALFMODE;
	agt->awake_time = ref + inmorph_count_mll(am->im, rslt);
#ifdef _TEST_HIT_
	printf(">  match %s\n",string_bank_ref(am->amap->sb, cnd->word));
#endif
      } else {
	agt->mode = HELLMODE;
#ifdef _TEST_HIT_
	printf(">  unmatch raw (%s)\n",string_bank_ref(am->amap->sb, cnd->word));
#endif
	return 0;
      }
    }
    break;

  case STD:
    if( agt->mode == HALFMODE ){
      agent_growup( am, agt_idx );
      agent_move_to_arc( agt, arc_idx );
      agt->mode = SLEEPMODE;
#ifdef _TEST_HIT_
      printf(">  sleep std (%s)\n",string_bank_ref(am->amap->sb, cnd->word));
#endif
    } else { // ACTIVEMODE
      if( ( cnd_check_std( am->im,
			   ref,
			   string_bank_ref(am->amap->sb, cnd->word),
			   cnd->len,
			   &rslt ) &0x2 ) != 0 ){
	agent_growup( am, agt_idx );
	agent_move_to_node( agt, arc->ed );
	agt->rfrd_syn = rslt;
	agt->rfrd_sem = rslt;
	agt->mode = HALFMODE;
	agt->awake_time = ref + inmorph_count_mll(am->im, rslt);
#ifdef _TEST_HIT_
	printf(">  match '%s'\n",string_bank_ref(am->amap->sb, cnd->word));
#endif
      } else {
	agt->mode = HELLMODE;
#ifdef _TEST_HIT_
	printf(">  unmatch std (%s)\n",string_bank_ref(am->amap->sb, cnd->word));
#endif
	return 0;
      }
    }
    break;

  case VARS:
    if( agt->mode == HALFMODE ){
      agent_growup( am, agt_idx );
      agent_move_to_arc( agt, arc_idx );
      agt->mode = SLEEPMODE;
#ifdef _TEST_HIT_
      printf(">  sleep vars (%s%d)\n", string_bank_ref(am->amap->sb, cnd->str), cnd->num);
#endif
    } else { // ACTIVEMODE
      if( ( cnd_check_preterm( am->im,
			       ref,
			       am->smap,
			       cnd->link,
			       &rslt) & 0x2 ) != 0 ){
	agent_growup( am, agt_idx );
	agent_move_to_node( agt, arc->ed );
	agt->rfrd_syn = rslt;
	agt->rfrd_sem = rslt;
	agt->mode = HALFMODE;
	agt->awake_time = ref + inmorph_count_mll(am->im, rslt);
#ifdef _TEST_HIT_
	printf(">  match %s%d\n", string_bank_ref(am->amap->sb, cnd->str), cnd->num);
#endif
      } else {
	agt->mode = HELLMODE;
#ifdef _TEST_HIT_
	printf(">  unmatch (%s%d)\n", string_bank_ref(am->amap->sb, cnd->str), cnd->num);
#endif
	return 0;
      }
    }
    break;

  case VAR: // VAR ϡmap_linkˤꡢVARS  VARA ѴƤϤ
    error(UNKNOWN,"across_arc switch( cnd->ctype )");
    break;
  } // end of switch( cnd->ctype )

  // ==================================================================
  // Ȼ arc(xx,yy,cc,Ȼ,...)

  switch( arc->ref ){
  case NONE:
    break;
  case SEM: // * ΤȤ
    agt->prfrd_sem = agt->rfrd_sem;
    break;
  case SYN: // ^ ΤȤ
    agt->prfrd_syn = agt->rfrd_syn;
    break;
  case BOTH: // *^  ^* ΤȤ
    agt->prfrd_sem = agt->rfrd_sem;
    agt->prfrd_syn = agt->rfrd_syn;
    break;
  }

  // ==================================================================
  //  arc(xx,yy,cc,rrr,)

  if( arc->mem != 0 ){
    mem = memory_pointer( am, arc->mem );
    switch( mem->type ){
    case SMEM: // # ΤȤ
      agent_store_local_result( am, agt, rslt );
      break;
      
    case CMEM: // cnt++ΤȤ
      agent_increase_counter( agt, mem->num );
      break;
      
    case LOC: // $ = ΤȤ
      agent_store_location_mark( agt, mem->loc, mem->offset );
      break;
    }
  }
  return 1;
}
