#!/usr/bin/ruby -Ke
# ֻ국Ÿץ
# 2005.6/28 by tokuhisa

# ===================================================================

def main(fin, fout)
  while( (line = fin.gets) != nil )
    if /\;/ =~ line.chomp.strip
      line = $`
    end
    if( line == "" )
      next
    end
    newline = expand00(line)
    if newline != nil
      fout.puts newline
    else
      $stderr.puts "error: "+ line
    end
  end
end

# ===================================================================

def expand00(line)
  if /^([^:]+):/ =~ line
    pid = $1
    body = $'
    newline = expand01([body])
    if newline == nil
      return nil
    else
      return newline.sort.uniq.collect{|newbody|
        pid+":"+newbody
      }
    end
  else
    return line
  end
end


# -------------------------------------------------------------------

def expand01(bodies)
  ans = []
  while bodies != []
    body = bodies.shift
    if /\$\d+/ =~ body
      newbody = expand02(body)
      if newbody == nil
        return nil
      end
      bodies += newbody
    else
      ans << body
    end
  end
  return ans
end

def expand02(body)
  if /(\$(\d+))\^/ =~ body
    prebody = $`
    postbody = $'
    dlnum = $2
    key = Regexp.new('\\'+$1)
    rslt = pickup_keydef(postbody)
    if rslt == nil
      return nil
    end
    keydef = rslt[0]
    postbody = rslt[1]
    if key =~ keydef
      return nil
    end

    newprebody = []
    while key =~ prebody
      newprebody << $`
      prebody = $'
    end
    newprebody << prebody

    newpostbody = []
    while key =~ postbody
      newpostbody << $`
      postbody = $'
    end
    newpostbody << postbody

    baselocation = newprebody.size - 1

    newbody = newprebody + newpostbody

    newbodies = []
    (newbody.size - 1).times{|i|
      newbodies << newbody[0..i].join + "#loc" + dlnum + "=" + (i - baselocation).to_s + keydef + newbody[(i+1)..-1].join
      		   
    }
    return newbodies
  else
    return [body]
  end
end


def pickup_keydef(str)
  if /^[A-Z]+\d+/ =~ str
    return $&,$'
  elsif /^[-]+/ =~ str
    return $&,$'
  elsif /^\^[a-z]+/ =~ str
    return $&,$'
  elsif /^[\(\{\[]/ =~ str
    keydef = $&
    depth = 1
    str = $'
    while depth != 0
      if /^[\(\{\[]/ =~ str
        depth += 1
        str = $'
        keydef += $&
      elsif /^[\)\}\]]/ =~ str
        depth -= 1
        str = $'
        keydef += $&
      elsif /^./ =~ str
        str = $'
        keydef += $&
      else
        return nil
      end
    end
    return keydef,str
  elsif /^\#\d+/ =~ str
    tmp1 = $&
    tmp2, rest = pickup_keydef($')
    return tmp1+tmp2, rest
  else
    return nil
  end
end


# ===================================================================

fin = File.open(ARGV[0])
fout = File.open(ARGV[1],"w")
main(fin,fout)
fout.close
fin.close
  
# puts expand01([ARGV[0]])
