#ifndef __INMORPH_H__
#define __INMORPH_H__

#include "multilist.h"
#include "keyword.h"
#include "eucmap.h"

typedef struct {
  char *cat;
  int cat_len;
  char *val;
  int val_len;
} MorphAttrStr;

typedef struct {
  char *pcode;
  char *std;
  int std_len;
  char *chs;
  int chs_len;
} MorphPosStr;

typedef struct {
  char border;
  char *raw;
  int raw_len;
} MorphLineStr;

typedef struct {
  Cnt cnt;	// ιԤ³
  int mls_idx;
  int mpl_head;
} MorphLineLink;

typedef struct {
  char *block;
  int block_max;
  MorphLineStr * mls;
  int mls_max;
  int mls_free;
  MorphPosStr *mps;
  int mps_max;
  int mps_free;
  MorphAttrStr *mas;
  int mas_max;
  int mas_free;
  MorphLineLink *mll;
  int mll_max;
  int mll_free;
  Multi2List *mpl;	// val1  mps Υǥval2  mal_head
  MultiList *mal;
} InMorph;



void inmorph_clear(InMorph *);
InMorph *inmorph_open(int, int, int, int, int, int, int);
void inmorph_close(InMorph *);
void inmorph_dump(InMorph *, FILE *);
void inmorph_load(InMorph *, FILE *);
void inmorph_set_eucbitmap(InMorph *, EucAllMap);

int inmorph_count_mll(InMorph *, int);  // ǥλؤññ
void inmorph_print_easily(InMorph *, int, FILE *);

// ref1  ref2 ϡʸηǥǡƱԤΤΤ򤵤
#define inmorph_same_morph_line(_im,_r1,_r2)\
	((_im)->mll[(_r1)].mls_idx == (_im)->mll[(_r2)].mls_idx)

#define inmorph_continue(_im,_ref)\
	((_im)->mll[(_ref)].cnt == CONT)

#endif
