#ifndef __MULTILIST_H__
#define __MULTILIST_H__

#include <stdio.h>

typedef struct {
  int val;
  int next;
} MLNode;

typedef struct {
  MLNode *node;
  int max;
  int free;
#ifdef _TEST_FREE_AREA_
  int entnum;
#endif
} MultiList;

void multilist_clear(MultiList *);
MultiList *multilist_open(int);
void multilist_close(MultiList *);
void multilist_dump(MultiList *, FILE *);

int multilist_new_head(MultiList *);
void multilist_clear_head(MultiList *, int);
void multilist_close_head(MultiList *, int);
void multilist_dump_head(MultiList *, int, FILE *);

void multilist_enqueue(MultiList *, int, int);
int multilist_dequeue(MultiList *, int);
void multilist_push(MultiList *, int, int);
int multilist_pop(MultiList *, int);
void multilist_dup(MultiList *, int, int);
#define multilist_empty(_ml,_hd) ((_ml)->node[(_hd)].next==0)
#define multilist_car(_ml,_hd) ((_ml)->node[(_ml)->node[(_hd)].next].val)
#define multilist_cdr(_ml,_hd) ((_ml)->node[(_hd)].next)

void multilist_remove_val(MultiList *, int, int);
void multilist_remove_list(MultiList *, int, int);
void multilist_insert_ow(MultiList *, int, int);

int multilist_member(MultiList *, int, int);


typedef struct {
  int val1;
  int val2;
  int next;
} ML2Node;

typedef struct {
  ML2Node *node;
  int max;
  int free;
#ifdef _TEST_FREE_AREA_
  int entnum;
#endif
} Multi2List;

void multi2list_clear(Multi2List *);
Multi2List *multi2list_open(int);
void multi2list_close(Multi2List *);
int multi2list_new_head(Multi2List *);
void multi2list_close_head(Multi2List *, int);
void multi2list_enqueue(Multi2List *, int, int, int);
ML2Node *multi2list_dequeue(Multi2List *, int);
void multi2list_push(Multi2List *, int, int, int);
ML2Node *multi2list_pop(Multi2List *, int);
void multi2list_dup(Multi2List *, int, int);
#define multi2list_empty(_ml,_hd) ((_ml)->node[(_hd)].next==0)
#define multi2list_car(_ml,_hd) (&(_ml)->node[(_ml)->node[(_hd)].next])
#define multi2list_cdr(_ml,_hd) ((_ml)->node[(_hd)].next)

ML2Node *multi2list_search_by_val1(Multi2List *, int, int);

#endif
