#include <stdio.h>
#include <stdlib.h>
#include "numstack.h"
#include "error.h"

NumStack *numstack_open(int size)
{
  NumStack *ans;

  ans = (NumStack *)malloc(sizeof(NumStack));
  if( ans == NULL )
    error(MALLOC_FAILED,"numstack_open 1");
  ans->stack = (int *)malloc(sizeof(int) * size);
  if( ans->stack == NULL )
    error(MALLOC_FAILED,"numstack_open 2");
  ans->max = size;
  numstack_clear(ans);
  return ans;
}


void numstack_close(NumStack *ns)
{
  free(ns->stack);
  free(ns);
}


void numstack_dump(NumStack *ns, FILE *fp)
{
  int i;

  for(i = 0 ; i < ns->sp ; i += 1)
    fprintf(fp, "  %d",ns->stack[i]);
  fprintf(fp, "\n");
}

void numstack_push(NumStack *ns, int v)
{
  if( ns->sp >= ns->max )
    error(OVER_FLOWED,"numstack_push");
  ns->stack[ns->sp++]=v;
}

int numstack_pop(NumStack *ns)
{
  if( ns->sp == 0 )
    error(UNDER_FLOWED,"numstack_pop");
  return ns->stack[--ns->sp];
}
