/*
 * pat2atype.c  sentence pattern parser  ʸѥAѴ 
 *                                              2005.6/12 by tokuhisa
 *						2005.6/28 updated
 */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "scanner.h"
#include "error.h"

#define MAX_INPUTLINE	1024		/* 1ʸθ */
#define MAX_PARTS	1024		/* 1ιʸǤθ */
#define MAX_MIXCOMP	1024		/* 1ĤνǤյ⹽ǿ */
#define MAX_NUMS_LEN	3		/* NUMS ʸĹθ */
#define MAX_POSMARK     20		/* 1$nμθ */

#define WORK_FILE	"/tmp/pat2atype_work"

//  SEL缡 SEQά OMSǤ MIXֻ POS
// ñ STR
// ̲å CHK=arc(x,y,cnt#==0,,cnt#++)


typedef enum {SEL,SEQ,OMS,MIX, STR, CHK, LOC} PartsType;

char *partslabel[] = {"SEL","SEQ","OMS","MIX", "STR", "CHK", "LOC"};

typedef struct parts {
  PartsType type;
  int memory;			/*  #m 0ʾͭ */
  union {
    struct {			/* STR ΤȤ */
      int word;			/* inputlineΰ */
      int length;		/*          Ĺ */
    };
    struct {
      int num;			/* CHK ֹ */
    };
    struct {			/* SEL/SEQ/OMS/MIX ΤȤ */
      int car;			/* Parts Х󥯤Υǥå */
      int cdr;			/* Parts Х󥯤Υǥå */
    };
    struct {			/* LOC  */
      int loc;			/* $x  xֹ */
      int offset;		/* $x = m m */
    };
  };
} Parts;

char inputline[MAX_INPUTLINE];

int index_of_parts;
Parts bank_of_parts[MAX_PARTS];

int last_cntr;			/* ȯԤ cnt# ֹ 0 ꥸ */


// ɬܻ
char importantwords[MAX_INPUTLINE];  /* ɬܻ̤Ǽ */
int impdepth; /* ˤʤȿ */

// ==================================================================
// bank_of_parts ɽ

void bank_of_parts_dump(FILE *fp)
{
  Parts *p;
  int i;

  for( i = 0 ; i < index_of_parts ; i += 1 ){
    p = &bank_of_parts[i];
    fprintf(fp,"%3d  ",i);
    switch( p->type ){
    case SEL:
      fprintf(fp,"SEL: car = %d  cdr = %d\n", p->car, p->cdr);
      break;
    case SEQ:
      fprintf(fp,"SEQ: car = %d  cdr = %d\n", p->car, p->cdr);
      break;
    case OMS:
      fprintf(fp,"OMS: car = %d  cdr = %d\n", p->car, p->cdr);
      break;
    case MIX:
      fprintf(fp,"MIX: car = %d  cdr = %d\n", p->car, p->cdr);
      break;
    case STR:
      fprintf(fp,"STR: word = %d  len = %d\n", p->word, p->length);
      break;
    case CHK:
      fprintf(fp,"CHK: num = %d\n", p->num);
      break;
    case LOC:
      fprintf(fp,"LOC: loc = %d  offset = %d\n", p->loc, p->offset);
      break;
    }
  }
}



// ====================================================================
// ʸ

int parse_SELECT(int, int *, int);
int parse_C_SELECT(int, int *, int);
int parse_SEQUENCE(int, int *, int);

// -------------------------------------------------------------------
// letters -> EUCS
//          | SQ EUCS SQ

int parse_LETTERS(int p, int *ans, int mnum)
{
  int len, myc, sum;

  if( (len = scan_EUCS(inputline,p)) > 0 ){
    sum = len;
    myc = index_of_parts++;
    if( index_of_parts >= MAX_PARTS )
      error(OVER_FLOWED,"parse_LETTERS 1");
    bank_of_parts[myc].type = STR;
    bank_of_parts[myc].word = p;
    bank_of_parts[myc].length = len;
    bank_of_parts[myc].memory = mnum;
    *ans = sum;

    // ɬܻѤν
    if( impdepth == 0 )
      strncat(importantwords, &inputline[p], len);
    // ޤ

    return myc;
  }

  if( (len = scan_SQ(inputline, p)) > 0 ){
    sum = len;
    if( (len = scan_EUCS(inputline, p + sum)) > 0 ){
      sum += len;
      if( (len = scan_SQ(inputline, p + sum)) > 0 ){
	sum += len;
	myc = index_of_parts++;
	if( index_of_parts >= MAX_PARTS )
	  error(OVER_FLOWED,"parse_LETTERS 2");
	bank_of_parts[myc].type = STR;
	bank_of_parts[myc].word = p;
	bank_of_parts[myc].length = sum;
	bank_of_parts[myc].memory = mnum;
	*ans = sum;

	// ɬܻѤν
	if( impdepth == 0 )
	  strncat(importantwords, &inputline[p], len);
	// ޤ

	return myc;
      }
    }
  }

  *ans = 0;
  return 0;
}


// constant -> BCAT | BCUT | COMMA    ʢ COMMA ̤
// 

int parse_CONSTANT(int p, int *ans, int mnum)
{
  int len, myc, sum;

  if( (len = scan_BCAT(inputline, p)) > 0 ){
    sum = len;
    myc = index_of_parts++;
    if( index_of_parts >= MAX_PARTS )
      error(OVER_FLOWED,"parse_CONSTANT 1");
    bank_of_parts[myc].type = STR;
    bank_of_parts[myc].word = p;
    bank_of_parts[myc].length = sum;
    bank_of_parts[myc].memory = mnum;
    *ans = sum;
    return myc;
  }
  if( (len = scan_BCUT(inputline, p)) > 0 ){
    sum = len;
    myc = index_of_parts++;
    if( index_of_parts >= MAX_PARTS )
      error(OVER_FLOWED,"parse_CONSTANT 2");
    bank_of_parts[myc].type = STR;
    bank_of_parts[myc].word = p;
    bank_of_parts[myc].length = sum;
    bank_of_parts[myc].memory = mnum;
    *ans = sum;
    return myc;
  }

  *ans = 0;
  return 0;
}


// variable -> LALPHAS NUMS
//	    |  DOT SALPHAS [NUMS]
//	    |  DOT SHARP SALPHAS [NUMS]
//	    |  SLASH [SALPHAS] [NUMS]

int parse_VARIABLE(int p, int *ans, int mnum)
{
  int len, myc, sum;

  if( (len = scan_LALPHAS(inputline, p)) > 0 ){
    sum = len;
    if( (len = scan_NUMS(inputline, p + sum)) > 0 ){
      sum += len;
      myc = index_of_parts++;
      if( index_of_parts >= MAX_PARTS )
	error(OVER_FLOWED,"parse_VARIABLE 1");
      bank_of_parts[myc].type = STR;
      bank_of_parts[myc].word = p;
      bank_of_parts[myc].length = sum;
      bank_of_parts[myc].memory = mnum;
      *ans = sum;
      return myc;
    }
  }

  if( (sum = scan_DOT(inputline, p)) > 0 ){
    if( (len = scan_SHARP(inputline, p + sum)) > 0 )
      sum += len;
    if( (len = scan_SALPHAS(inputline, p + sum)) > 0 ){
      sum += len;
      if( (len = scan_NUMS(inputline, p + sum)) > 0 )
	sum += len;
      myc = index_of_parts++;
      if( index_of_parts >= MAX_PARTS )
	error(OVER_FLOWED,"parse_VARIABLE 2");
      bank_of_parts[myc].type = STR;
      bank_of_parts[myc].word = p;
      bank_of_parts[myc].length = sum;
      bank_of_parts[myc].memory = mnum;
      *ans = sum;
      return myc;
    }
  }

  if( (sum = scan_SLASH(inputline, p)) > 0 ){
    if( (len = scan_SALPHAS(inputline, p + sum)) > 0 )
      sum += len;
    if( (len = scan_NUMS(inputline, p + sum)) > 0 )
      sum += len;
    myc = index_of_parts++;
    if( index_of_parts >= MAX_PARTS )
      error(OVER_FLOWED,"parse_VARIABLE 3");
    bank_of_parts[myc].type = STR;
    bank_of_parts[myc].word = p;
    bank_of_parts[myc].length = sum;
    bank_of_parts[myc].memory = mnum;
    *ans = sum;
    return myc;
  }

  *ans = 0;
  return 0;
}


// function -> HAT SALPHAS
//          |  PL semattrlist PR         ʢ ̣°̤

int parse_FUNCTION(int p, int *ans, int mnum)
{
  int len, myc, sum;

  if( (len = scan_HAT(inputline, p)) > 0 ){
    sum = len;
    if( (len = scan_SALPHAS(inputline, p + sum)) > 0 ){
      sum += len;
      myc = index_of_parts++;
      if( index_of_parts >= MAX_PARTS )
	error(OVER_FLOWED,"parse_FUNCTION 1");
      bank_of_parts[myc].type = STR;
      bank_of_parts[myc].word = p;
      bank_of_parts[myc].length = sum;
      bank_of_parts[myc].memory = mnum;
      *ans = sum;
      return myc;
    }
  }

  *ans = 0;
  return 0;
}


// -------------------------------------------------------------------
// element -> letters | constant | variable | function
//

int parse_ELEMENT(int p, int *ans, int mnum)
{
  int len, c;

  if( (c = parse_LETTERS(p, &len, mnum)) > 0 ){
    *ans = len;
    return c;
  }

  if( (c = parse_CONSTANT(p, &len, mnum)) > 0 ){
    *ans = len;
    return c;
  }
  if( (c = parse_VARIABLE(p, &len, mnum)) > 0 ){
    *ans = len;
    return c;
  }
  if( (c = parse_FUNCTION(p, &len, mnum)) > 0 ){
    *ans = len;
    return c;
  }

  *ans = 0;
  return 0;
}



// -------------------------------------------------------------------
// factor -> element
//        |  PL select PR
//        |  BL select BR
//        |  ML select MR
//        |  DL NUMS       ʢ 

int parse_FACTOR(int p, int *ans, int mnum)
{
  int len, sum, c, myc;

  if( (len = scan_PL(inputline, p)) > 0 ){
    sum = len;
    impdepth += 1;  // ɬܻѤο
    if( (c = parse_SELECT(p + sum, &len, mnum)) > 0 ){
      sum += len;
      if( (len = scan_PR(inputline, p + sum)) > 0 ){
	*ans = sum + len;
	impdepth -= 1;  // ɬܻѤο
	return c;
      }
    }
    impdepth -= 1; // Ƥξ硢depth ᤹
  }

  if( (len = scan_BL(inputline, p)) > 0 ){
    sum = len;
    impdepth += 1;  // ɬܻѤο
    if( (c = parse_SELECT(p + sum, &len, mnum)) > 0 ){
      sum += len;
      if( (len = scan_BR(inputline, p + sum)) > 0 ){
	sum += len;
	myc = index_of_parts++;
	if( index_of_parts >= MAX_PARTS )
	  error(OVER_FLOWED,"parse_FACTOR 1");
	bank_of_parts[myc].type = OMS;
	bank_of_parts[myc].car = c;
	bank_of_parts[myc].cdr = 0;
	*ans = sum;
	impdepth -= 1;  // ɬܻѤο
	return myc;
      }
    }
    impdepth -= 1;  // Ƥξ硢depth ᤹
  }

  if( (len = scan_ML(inputline, p)) > 0 ){
    sum = len;
    if( (c = parse_C_SELECT(p + sum, &len, mnum)) > 0 ){
      sum += len;
      if( (len = scan_MR(inputline, p + sum)) > 0 ){
	sum += len;
	myc = index_of_parts++;
	if( index_of_parts >= MAX_PARTS )
	  error(OVER_FLOWED,"parse_FACTOR 2");
	bank_of_parts[myc].type = MIX;
	bank_of_parts[myc].car = c;
	bank_of_parts[myc].cdr = 0;
	*ans = sum;
	return myc;
      }
    }
  }

  if( (c = parse_ELEMENT(p, &len, mnum)) > 0 ){
    *ans = len;
    return c;
  }

  *ans = 0;
  return 0;
}


// -------------------------------------------------------------------
// term -> factor
//      |  SHARP NUMS factor
//	|  SHARP LOC NUMS EQ [MINUS] NUMS ü
//      |  DL NUMS HAT ML sequence MR  ʢ  

int parse_TERM(int p, int *ans, int mnum)
{
  int len, sum, c;
  char tmp[MAX_NUMS_LEN];
  int num1, sgn, num2;

  if( (len = scan_SHARP(inputline, p)) > 0 ){
    sum = len;
    if( (len = scan_NUMS(inputline, p + sum)) > 0 ){
      if( len > MAX_NUMS_LEN )
	exit(-1);
      strncpy(tmp, &inputline[p + sum], len);
      tmp[len] = '\0';
      mnum = atoi(tmp);
      sum += len;
      if( (c = parse_FACTOR(p + sum, &len, mnum)) > 0 ){
	sum += len;
	*ans = sum;
	return c;
      }
    }
  }

  if( (sum = scan_SHARP(inputline, p)) > 0 ){
    if( (len = scan_LOC(inputline, p + sum)) > 0 ){
      sum += len;
      if( (len = scan_NUMS(inputline, p + sum)) > 0 ){
	if( len > MAX_NUMS_LEN )
	  exit(-1);
	strncpy(tmp, &inputline[p + sum], len);
	tmp[len] = '\0';
	num1 = atoi(tmp);
	sum += len;
	if( (len = scan_EQ(inputline, p + sum)) > 0 ){
	  sum += len;
	  sgn = 1;
	  if( (len = scan_MINUS(inputline, p + sum)) > 0 ){
	    sgn = -1;
	    sum += len;
	  }
	  if( (len = scan_NUMS(inputline, p + sum)) > 0 ){
	    if( len > MAX_NUMS_LEN )
	      exit(-1);
	    strncpy(tmp, &inputline[p + sum], len);
	    tmp[len] = '\0';
	    num2 = sgn * atoi(tmp);
	    c = index_of_parts++;
	    if( index_of_parts >= MAX_PARTS )
	      error(OVER_FLOWED,"parse_TERM");
	    bank_of_parts[c].type = LOC;
	    bank_of_parts[c].memory = -1;
	    bank_of_parts[c].loc = num1;
	    bank_of_parts[c].offset = num2;
	    *ans = sum + len;
	    return c;
	  }
	}
      }
    }
  }

  if( (c = parse_FACTOR(p, &len, mnum)) > 0 ){
    *ans = len;
    return c;
  }
  *ans = 0;
  return 0;
}


// -------------------------------------------------------------------
// sequence -> term+

int parse_SEQUENCE(int p, int *ans, int mnum)
{
  int len, sum, c, myc, tmp, tail;

  if( (c = parse_TERM(p, &len, mnum)) > 0 ){
    myc = index_of_parts++;
    if( index_of_parts >= MAX_PARTS )
      error(OVER_FLOWED,"parse_SEQUENCE 1");
    bank_of_parts[myc].type = SEQ;
    bank_of_parts[myc].car = c;
    bank_of_parts[myc].cdr = 0;
    tail = myc;
    sum = len;
    while( (c = parse_TERM(p + sum, &len, mnum)) > 0 ){
      sum += len;
      tmp = index_of_parts++;
      if( index_of_parts >= MAX_PARTS )
	error(OVER_FLOWED,"parse_SEQUENCE 2");
      bank_of_parts[tmp].type = SEQ;
      bank_of_parts[tmp].car = c;
      bank_of_parts[tmp].cdr = 0;
      bank_of_parts[tail].cdr = tmp;
      tail = tmp;
    }
    *ans = sum;
    return myc;
  }
  *ans = 0;
  return 0;
}


// -------------------------------------------------------------------
// c_select -> sequence (COMMA sequence)*

int parse_C_SELECT(int p, int *ans, int mnum)
{
  int len, sum, c, myc, tmp, tail;

  if( (c = parse_SEQUENCE(p, &len, mnum)) > 0 ){
    sum = len;
    myc = index_of_parts++;
    if( index_of_parts >= MAX_PARTS )
      error(OVER_FLOWED,"parse_C_SELECT 1");
    bank_of_parts[myc].type = SEL;
    bank_of_parts[myc].car = c;
    bank_of_parts[myc].cdr = 0;
    tail = myc;
    while( (len = scan_COMMA(inputline, p + sum)) > 0 ){
      sum += len;
      if( (c = parse_SEQUENCE(p + sum, &len, mnum)) > 0 ){
	sum += len;
	tmp = index_of_parts++;
	if( index_of_parts >= MAX_PARTS )
	  error(OVER_FLOWED,"parse_C_SELECT 2");
	bank_of_parts[tmp].type = SEL;
	bank_of_parts[tmp].car = c;
	bank_of_parts[tmp].cdr = 0;
	bank_of_parts[tail].cdr = tmp;
	tail = tmp;
      }	else {
	*ans = 0;
	return 0;
      }
    }
    *ans = sum;
    return myc;
  }

  *ans = 0;
  return 0;
}


// select -> sequence (PIPE sequence)*

int parse_SELECT(int p, int *ans, int mnum)
{
  int len, sum, c, myc, tmp, tail;

  if( (c = parse_SEQUENCE(p, &len, mnum)) > 0 ){
    sum = len;
    myc = index_of_parts++;
    if( index_of_parts >= MAX_PARTS )
      error(OVER_FLOWED,"parse_SELECT 1");
    bank_of_parts[myc].type = SEL;
    bank_of_parts[myc].car = c;
    bank_of_parts[myc].cdr = 0;
    tail = myc;
    while( (len = scan_PIPE(inputline, p + sum)) > 0 ){
      sum += len;
      if( (c = parse_SEQUENCE(p + sum, &len, mnum)) > 0 ){
	sum += len;
	tmp = index_of_parts++;
	if( index_of_parts >= MAX_PARTS )
	  error(OVER_FLOWED,"parse_SELECT 2");
	bank_of_parts[tmp].type = SEL;
	bank_of_parts[tmp].car = c;
	bank_of_parts[tmp].cdr = 0;
	bank_of_parts[tail].cdr = tmp;
	tail = tmp;
      }	else
	return 0;
    }

    *ans = sum;
    return myc;
  }

  *ans = 0;
  return 0;
}


// -------------------------------------------------------------------
// body -> sequence

int parse_BODY(int p, int *ans)
{
  int len, c;

  //  if( (c = parse_SELECT(p, &len, -1)) > 0 ){
  if( (c = parse_SEQUENCE(p, &len, -1)) > 0 ){
    *ans = len;
    return c;
  }

  *ans = 0;
  return 0;
}



// --------------------------------------------------------------------
// ʸϤθƽФ

int parse_main(char *in, char *pid, int idlen)
{
  int s, len, c, i;

  // --------------------  --------------------
  s = strlen(in);
  if( s >= MAX_INPUTLINE )
    return -2;
  
  strcpy(inputline, in);

  index_of_parts = 1;
  for( i = 0; i < MAX_PARTS ; i += 1 ){
    bank_of_parts[i].memory = -1;
  }

  last_cntr = 0;

  // -------------------- ϼ¹ --------------------
  if( (c = parse_BODY(0,&len)) > 0 ){
    if( s == len ) {    // ----------  ----------
      return c;
    }
  }

  // -------------------- ʸˡ顼 --------------------
  for( i = 0; i < idlen; i += 1 )
    printf("%c",pid[i]);
  printf(":");
  printf("%s\n",inputline);
  for( i = 0; i < len + idlen + 1; i += 1 )
    printf(" ");
  for( ; i < s ; i += 1)
    printf("^");
  printf(" Syntax Error\n");
  return 0;
}



// --------------------------------------------------------------------
// ưå

void print_parse(int start)
{
  int i,j, t;

  printf("start = %d\n",start);
  printf("index = %d\n",index_of_parts);

  for( i = 1; i < index_of_parts; i += 1 ){
    t = bank_of_parts[i].type;
    printf("%2d:   %-5s ", i, partslabel[t]);
    switch( t ){
    case SEL:
    case SEQ:
    case OMS:
    case MIX:
      printf("  %2d   %2d\n", bank_of_parts[i].car, bank_of_parts[i].cdr);
      break;

    case STR:
      for( j = 0; j < bank_of_parts[i].length; j += 1 )
	printf("%c",inputline[bank_of_parts[i].word + j]);
      if( bank_of_parts[i].memory >= 0 )
	printf("  #%d",bank_of_parts[i].memory);
      printf("\n");
      break;

    case CHK:
      printf(" cnt%d==0 / cnt%d++\n", bank_of_parts[i].num,  bank_of_parts[i].num);
      break;

    case LOC:
      printf(" $%d=%d \n", bank_of_parts[i].loc, bank_of_parts[i].offset);
      break;
    }
  }
}


// ===================================================================
// ʸǤŸ

// -------------------------------------------------------------------
// {A,B,C}  MIX(SEL(A,B,C))
//                    
// SEQ(SEL(SEQ(CHK1,A),SEQ(CHK2,B),SEQ(CHK3,C)),
//     SEL(SEQ(CHK1,A),SEQ(CHK2,B),SEQ(CHK3,C)),
//     SEL(SEQ(CHK1,A),SEQ(CHK2,B),SEQ(CHK3,C)))
//
//  cnt# ɬפʤƤ롣
// CHK  arc(i,j,cnt#==0,,cnt#++) ΥѴ
// ̲ϡcnt# == 0
// ̲᤹ȡcnt# += 1
// ĤޤꡢΤξȹǡɬ A, B, C Τ줾1̲᤹СŬ硣

int expand_mix_parts(int st)
{
  int chkcndline[MAX_MIXCOMP];
  int ccsp;
  int ms, mp, i, j, mixp, seqpos, selpos, seqtail, seltail;

  ms = 0;
  for( mp = bank_of_parts[st].car; mp != 0; mp = bank_of_parts[mp].cdr ){
    ccsp = index_of_parts++;
    if( index_of_parts >= MAX_PARTS )
      error(OVER_FLOWED,"expand_mix_parts 1");
    chkcndline[ms++] = ccsp;
    bank_of_parts[ccsp].type = SEQ;
    bank_of_parts[ccsp].car = index_of_parts;
    bank_of_parts[index_of_parts].type = CHK;
    bank_of_parts[index_of_parts].num = last_cntr++;
    index_of_parts += 1;
    if( index_of_parts >= MAX_PARTS )
      error(OVER_FLOWED,"expand_mix_parts 2");
    bank_of_parts[ccsp].cdr = index_of_parts;
    bank_of_parts[index_of_parts].type = SEQ;
    bank_of_parts[index_of_parts].car = bank_of_parts[mp].car;
    bank_of_parts[index_of_parts].cdr = 0;
    index_of_parts += 1;
    if( index_of_parts >= MAX_PARTS )
      error(OVER_FLOWED,"expand_mix_parts 3");
  }

  seqtail = mixp = index_of_parts;
  for( i = 0; i < ms; i += 1 ){
    seqpos = index_of_parts++;
    if( index_of_parts >= MAX_PARTS )
      error(OVER_FLOWED,"expand_mix_parts 4");
    bank_of_parts[seqtail].cdr = seqpos;
    bank_of_parts[seqpos].type = SEQ;
    bank_of_parts[seqpos].car = seltail = index_of_parts;
    bank_of_parts[seqpos].cdr = 0;
    seqtail = seqpos;
    for( j = 0; j < ms; j += 1 ){
      selpos = index_of_parts++;
      if( index_of_parts >= MAX_PARTS )
	error(OVER_FLOWED,"expand_mix_parts 5");
      bank_of_parts[seltail].cdr = selpos;
      bank_of_parts[selpos].type = SEL;
      bank_of_parts[selpos].car = chkcndline[j];
      bank_of_parts[selpos].cdr = 0;
      seltail = selpos;
    }
  }
  return mixp;
}


// ===================================================================
// arc 


int to_arc00(FILE *fout, int st, int bg, int ed, int nxt)
{
  int q, newnxt, i;
  int mixp;

  if( st == 0 ){
    return nxt;
  }
  switch( bank_of_parts[st].type ){
  case STR:
    fprintf(fout, "  arc(%d,%d,", bg, ed);
    for( i = 0; i < bank_of_parts[st].length; i += 1 )
      fprintf(fout, "%c", inputline[bank_of_parts[st].word + i]);
    if( bank_of_parts[st].memory >= 0 )
      fprintf(fout,",,#%d",bank_of_parts[st].memory);
    fprintf(fout,")\n");
    return nxt;

  case CHK:
    fprintf(fout, "  arc(%d,%d,cnt%d==0,,cnt%d++)\n", bg, ed, bank_of_parts[st].num, bank_of_parts[st].num);
    return nxt;
    break;

  case LOC:
    fprintf(fout, "  arc(%d,%d,jump,,$%d=%d)\n", bg, ed, bank_of_parts[st].loc, bank_of_parts[st].offset);
    return nxt;

  case SEL:
    newnxt = nxt;
    for( q = st; q != 0; q = bank_of_parts[q].cdr ){
      newnxt = to_arc00(fout, bank_of_parts[q].car, bg, ed, newnxt);
    }
    return newnxt;
    break;

  case OMS:
    newnxt = nxt;
    for( q = st; q != 0; q = bank_of_parts[q].cdr ){
      newnxt = to_arc00(fout, bank_of_parts[q].car, bg, ed, newnxt);
    }
    fprintf(fout, "  arc(%d,%d,jump)\n", bg, ed);
    return newnxt;
    break;

  case SEQ:
    q = bank_of_parts[st].cdr;
    if( q == 0 ){
      return to_arc00(fout, bank_of_parts[st].car, bg, ed, nxt);
    } else {
      newnxt = to_arc00(fout, bank_of_parts[st].car, bg, nxt, nxt+1);
      return to_arc00(fout, q, nxt, ed, newnxt);
    }
    break;

  case MIX:
    mixp = expand_mix_parts(st);
    return to_arc00(fout, mixp, bg, ed, nxt);
    break;

  default:
    printf("error\n");
    exit(-1);
  }
}


void to_arc(FILE *fout, int start)
{
  to_arc00(fout, start, 1,2,3);
  fprintf(fout, "  arc(2,0,pop)\n");
}


// --------------------------------------------------------------------
//

void spp_one(FILE *fout, char *line)
{
  char *pid, *body;
  int len, i;
  int c;

  pid = line;
  for( len = 0; line[len] != ':'; len += 1 ){}
  body = &line[len+1];
  if( (c = parse_main(body, pid, len)) > 0 ){
    for( i = 0; i < len; i += 1)
      fprintf(fout, "%c", pid[i]);

    // ɬܻѤν
    fprintf(fout, "  ; {%s}\n",importantwords);
    to_arc(fout,c);
    fprintf(fout,"end\n");
  }
}

// ==================================================================
// ֻ국Ÿ

void expand_location_mark(char *infile, char *workfile)
{
  char command[BUFSIZ];

  strcpy(command,"./expand_location_mark.rb ");
  strcat(command,infile);
  strcat(command," ");
  strcat(command,workfile);
  system(command);
}




// ===================================================================
void show_help()
{
  fprintf(stderr,"ʸѥϴ: pat2atype patternfile [atypefile]\n");
  fprintf(stderr,"                                       version 2005.6/19 by tokuhisa\n");
  fprintf(stderr,"                                         since 2005.6/12 by tokuhisa\n");
  fprintf(stderr,"\n");
  fprintf(stderr,"  б   ѿؿ̡ɸ̡( )[ ]{ }\n");
  fprintf(stderr,"  б Υ桢ؿֻ국\n");
  fprintf(stderr,"  ̤б ̣°󡢻̴ؿޥؿ\n");
}

// -------------------------------------------------------------------

int main(int argc, char *argv[])
{
  FILE *fin, *fout;
  char line[BUFSIZ];
  int len;

  // --------------------  --------------------
  if( argc < 2 || argc > 3 ){
    show_help();
    exit(1);
  } else if( strcmp("-h", argv[1]) == 0
	     || strcmp("--help", argv[1]) == 0
	     || strcmp("-?", argv[1]) == 0 ) {
    show_help();
    exit(1);
  } else {
    fin = fopen(argv[1],"r");
    if( fin == NULL ){
      error(NO_FILE_OR_DIRECTORY, argv[1]);
    }
    fclose(fin);
    expand_location_mark(argv[1],WORK_FILE);
    fin = fopen(WORK_FILE,"r");
    if( fin == NULL ){
      error(SYNTAX_ERROR,argv[1]);
    }
    if( argc == 3 ){
      fout = fopen(argv[2],"w");
      if( fout == NULL ){
	error(NO_FILE_OR_DIRECTORY, argv[2]);
      }
    } else
      fout = stdout;
  }

  // --------------- ѥեɤȲ ---------------
  while( fgets(line, BUFSIZ, fin) != NULL ){
    len = strlen(line);
    if( line[len-1] == '\n' )
      line[len-1] = '\0';
    else
      error(OVER_FLOWED,"line[BUFSIZ]");

    importantwords[0] = '\0'; // ɬܻѳǼΥꥢ
    impdepth = 0;
    spp_one(fout, line);
  }

  // --------------------  --------------------

  if( argc == 3 )
    fclose(fout);
  fclose(fin);

  return 0;
}
