#!/usr/bin/ruby -Ke
# rule2arc
# 롼뵭Ҥ A 
# 2005.6/3 by tokuhisa

# ====================================================================
def show_help
  $stderr.puts [
    "rule2arc <ե> <Aե> [<Sե>]",
    "롼뵭Ҥե",
    "                                           2005.6/3 by tokuhisa",
    " ",
    "   ȡߥ󤫤ޤǤɤ߼ΤƤ롥",
    "             Ԥɤ߼ΤƤ롥",
    "   롼ΰ衧ǥեȤǡ롼ΰ",
    "   ΰ衧<s>׹Ԥ</s>׹Ԥδ֤ϡA",
    "   ӷΰ衧<a>׹Ԥ</a>׹Ԥδ֤ϡS",
    "",
    "   롼ΰǤϡʸ§񤯡㡥S -> NP VPˡ",
    "   ڡڤȤ롥롼ϡAȤƽϤ롥",
    "   ӷΰǤϡ̾ɤεҤ򤹤롥"
  ]
end


# ====================================================================
def analyse_arguments
  option = Hash.new(false)
  s = ARGV.size
  if s == 3
    option['ifile'] = ARGV[0]
    option['ofilea'] = ARGV[1]
    option['ofiles'] = ARGV[2]
  elsif s == 2
    option['ifile'] = ARGV[0]
    option['ofilea'] = ARGV[1]
  else
    option['help'] = true
  end
  return option
end


# ====================================================================

class Trie
  def initialize
    @nodemax = 1
    @root = @nodemax
    @arctable = Hash.new
    @arctable[@root] = Hash.new
  end

  def entry(keys)
    pnt = @root
    keys.each{|key|
      nxts = @arctable[pnt]
      nxt = nxts[key]
      if nxt == nil
        nxt = (@nodemax += 1)
	nxts[key] = nxt
	@arctable[pnt] = nxts
	@arctable[nxt] = Hash.new
      end
      pnt = nxt
    }
    nxts = @arctable[pnt]
    nxts["pop"] = 0
    @arctable[pnt] = nxts
  end

  def print_arc(fout,space,limit)
    arcs = []
    @arctable.each_pair{|n1,key_n2|
      key_n2.each_pair{|key,n2|
        arcs << [n1,n2,key]
      }
    }
    arcs = arcs.sort{|a,b|
      if a[0] == b[0]
        if a[1] == b[1]
          a[2] <=> b[2]
        else
          a[1] <=> b[1]
        end
      else
        a[0] <=> b[0]
      end
    }
    fout.printf("%s",space)
    n1 = arcs[0][0]
    cnt = space.size
    arcs.each{|a|
      sa = sprintf(" arc(%d,%d,%s)",a[0],a[1],a[2])
      cnt += sa.size
      if( (a[0] != n1) || (cnt > limit) )
        fout.printf("\n%s",space)
        n1 = a[0]
        cnt = space.size + sa.size
      end
      fout.printf(sa)
    }
    fout.printf("\n")  
  end

  def change_number(src,dst)   # src  dst ˤ
    newarctable = Hash.new
    @arctable.each_pair{|n1,keyn2|
      newnxts = Hash.new
      keyn2.each_pair{|key,n2|
        if n2 == src
          newnxts[key] = dst
        else
          newnxts[key] = n2
        end
      }
      if n1 == src
        newarctable[dst] = newnxts
      else
        newarctable[n1] = newnxts
      end
    }
    @arctable = newarctable
  end

  def compress
    # ƱΤŤͤʥѥȥ쥷ĥ꡼
    begin
      arclist = @arctable.to_a
      s = arclist.size
      i = 0
      cpys = []
      while i < s - 1
        j = i + 1
        while j < s
          if arclist[i][1] == arclist[j][1]
            cpys << arclist[j][0]
          end
          j += 1
        end
        if cpys != []
          cpys.each{|dst|
            change_number(arclist[i][0],dst)
          }
          break
        end
        i += 1
      end
    end while cpys != []

    # ֹη֤
    nodes = @arctable.keys.sort
    s = nodes.size
    i = 1
    while i <= s
      $stderr.flush
      if i != nodes[i - 1]
        change_number(nodes[i - 1],i)
      end
      i += 1
    end
  end
end

# ====================================================================

def expand_bracket(body)
  ans = [""]
  while /\[([^\]]+)\]/ =~ body
    body = $'
    ans = set_all(ans, $`)
    ans = dup_set(ans, [$1,""])
  end
  ans = set_all(ans,body)
  return ans
end

def expand_parenthesis(body)
  ans = [""]
  while /\(([^\)]+)\)/ =~ body
    body = $'
    ans = set_all(ans, $`)
    ans = dup_set(ans,$1.split(/\|/))
  end
  ans = set_all(ans,body)
  return ans
end

def set_all(bodies,term)
  ans = []
  bodies.each{|body|
    ans << body + term
  }
  return ans
end

def dup_set(bodies,terms)      
  ans = []
  terms.each{|term|
    ans += set_all(bodies.dup,term)
  }
  return ans
end

# ====================================================================

def rule2arc
  option = analyse_arguments
  if option['help']
    show_help
    exit
  end

  if File.exist?(option['ifile'])
    fin = File.open(option['ifile'])
  else
    $stderr.puts "No such file or directory: "+option['ifile']
    exit
  end
  if option['ofiles'] != false
    fouts = File.open(option['ofiles'],'w')
  else
    fouts = $stdout
  end
  fouta = File.open(option['ofilea'],'w')

  mode = 0
  headlist = []
  bodylist = Hash.new
  arclist = Hash.new
  slist = []
  head = ""
  while( (line = fin.gets) != nil )
    if /\;/ =~ line
      line = $`
    else
      line = line.chomp
    end
    line = line.gsub(/\s+$/,"")
    if line == ""
      next
    end

    case mode
    when 0
      if /\<a\>/i =~ line
        mode = 1
      elsif /\<s\>/i =~ line
        mode = 3
      elsif /\-\>/ =~ line
        head = $`.strip
        bodies = []
        expand_parenthesis($').each{|b1|
          bodies += expand_bracket(b1)
        }
        bodies.each{|b|
          body = b.strip.split(/\s+/).collect{|x|
            if /\^setmark([*\^]+)/ =~ x
              $`+"^setmark("+$1+")"
            elsif /\*\^$/ =~ x
              $`+",*^"
            elsif /\^\*$/ =~ x
              $`+",*^"
            elsif /\^$/ =~ x
              $`+",^"
            elsif /\*$/ =~ x
              $`+",*"
            else
              x
            end
          }
          if bodylist[head] == nil
            headlist << ['r',head]
            bodylist[head] = Trie.new
            bodylist[head].entry(body)
          else
            bodylist[head].entry(body)
          end
        }
      end
    when 1
      head = line.strip
      headlist << ['a',head]
      arclist[head] = [head]
      mode = 2
    when 2
      if /\<\/a\>/i =~ line
        mode = 0
      else
        arclist[head] << line
      end
    when 3
      if /\<\/s\>/i =~ line
        mode = 0
      else
        slist << line
      end
    end
  end

  headlist.each{|h|
    case h[0]
    when 'r'
      fouta.puts h[1]
      bodylist[h[1]].compress
      bodylist[h[1]].print_arc(fouta,"  ",80)
      fouta.puts "end"
      fouta.printf("\n")
    when 'a'
      fouta.puts arclist[h[1]]
        fouta.printf("\n")
    end
  }
  fouts.puts slist
end

# ====================================================================

if $0 =~ /\/rule2linear.rb$/
  rule2arc
end
