/* stype.c
 * S-Type եȥޥåץե
 *
 * 2005.6/19 by tokuhisa
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "stype.h"
#include "string_bank.h"
#include "scanner.h"
#include "error.h"

// -------------------------------------------------------------------

#define MAX_BLOCK_SIZE	1000000		// 10000ԡ100ʸ/
#define MAX_LINE	100000		// 100000ʸ/

// ===================================================================
// Хѿ

char stypeblock[MAX_BLOCK_SIZE];


// ===================================================================
// 

void preterm_bank_open(SType *s, int size)
{
  s->ptb = (PreTermBank *)malloc(sizeof(PreTermBank));
  if( s->ptb == NULL )
    error(MALLOC_FAILED,"preterm_bank_open 1");
  s->ptb->preterm = (PreTerm *)malloc(sizeof(PreTerm) * size);
  if( s->ptb->preterm == NULL )
    error(MALLOC_FAILED,"preterm_bank_open 2");
  s->ptb->max = size;
  s->ptb->free = 0;
}


void preterm_bank_clear(SType *s)
{
  s->ptb->free = 0;
}


void preterm_bank_close(SType *s)
{
  free(s->ptb->preterm);
  free(s->ptb);
  s->ptb = NULL;
}


void preterm_bank_dump(SType *s, FILE *fp)
{
  int i;

  fprintf(fp,"PreTermBank (max = %d)\n", s->ptb->max);
  for( i = 0; i < s->ptb->free ; i += 1 )
    fprintf(fp, "%d:[%s,t%d,%d]\n", i, string_bank_ref(s->sb,s->ptb->preterm[i].name),s->ptb->preterm[i].dl, s->ptb->preterm[i].dl_num);
}


void preterm_bank_save(SType *s, FILE *fp)
{
  fprintf(fp,"%d %d\n", s->ptb->max, s->ptb->free);
  fwrite(s->ptb->preterm, sizeof(PreTerm), s->ptb->free, fp);
}


void preterm_bank_load(SType *s, FILE *fp)
{
  s->ptb = (PreTermBank *)malloc(sizeof(PreTermBank));
  if( s->ptb == NULL )
    error(MALLOC_FAILED,"preterm_bank_load 1");
  fscanf(fp,"%d %d\n", &s->ptb->max, &s->ptb->free);
  s->ptb->preterm = (PreTerm *)malloc(sizeof(PreTerm) * s->ptb->max);
  if( s->ptb->preterm == NULL )
    error(MALLOC_FAILED,"preterm_bank_load 2");
  fread(s->ptb->preterm, sizeof(PreTerm), s->ptb->free, fp);
}


void preterm_bank_strip(SType *s)
{
  s->ptb->max = s->ptb->free + 1;
}



// -------------------------------------------------------------------

void term_body_bank_open(SType *s, int size)
{
  s->dlb = (DefLineBank *)malloc(sizeof(DefLineBank));
  if( s->dlb == NULL )
    error(MALLOC_FAILED,"term_body_bank_open 1");
  s->dlb->dline = (DefLine *)malloc(sizeof(DefLine) * size);
  if( s->dlb->dline == NULL )
    error(MALLOC_FAILED,"term_body_bank_open 2");
  s->dlb->max = size;
  s->dlb->free = 0;
}


void term_body_bank_clear(SType *s)
{
  s->dlb->free = 0;
}


void term_body_bank_close(SType *s)
{
  free(s->dlb->dline);
  free(s->dlb);
  s->dlb = NULL;
}


void term_body_bank_dump(SType *s, FILE *fp)
{
  int i;

  fprintf(fp,"DefLineBank (max = %d)\n", s->dlb->max);
  for( i = 0; i < s->dlb->free; i += 1){
    fprintf(fp, "t%d:[",i);
    switch(s->dlb->dline[i].sign){
    case NEG:
      fprintf(fp,"-, ");
      break;
    case POS:
      fprintf(fp,"+, ");
      break;
    }
    switch(s->dlb->dline[i].lctype){
    case NOLC:
      fprintf(fp,"NOLC, ---, ");
      break;
    case RAWLC:
      fprintf(fp,"RAWLC, ");
      fprintf(fp,"%s, ",string_bank_ref(s->sb,s->dlb->dline[i].lcstr));
      break;
    case STDLC:
      fprintf(fp,"STDLC, ");
      fprintf(fp,"%s, ",string_bank_ref(s->sb,s->dlb->dline[i].lcstr));
      break;
    case PHILC:
      fprintf(fp,"PHILC, ");
      fprintf(fp,"%s, ",string_bank_ref(s->sb,s->dlb->dline[i].lcstr));
      break;
    }
    switch(s->dlb->dline[i].pctype){
    case NO:
      fprintf(fp,"NO, ");
      break;
    case EX:
      fprintf(fp,"EX, ");
      fprintf(fp,"%c%c%c%c, ",s->dlb->dline[i].pc[0],s->dlb->dline[i].pc[1],s->dlb->dline[i].pc[2],s->dlb->dline[i].pc[3]);
      break;
    }
    switch(s->dlb->dline[i].sctype){
    case NO:
      fprintf(fp,"NO]\n");
      break;
    case EX:
      fprintf(fp,"EX, s%d, %d]\n",s->dlb->dline[i].scidx,s->dlb->dline[i].scnum);
      break;
    }
  }
}


void term_body_bank_save(SType *s, FILE *fp)
{
  fprintf(fp,"%d %d\n", s->dlb->max, s->dlb->free);
  fwrite(s->dlb->dline, sizeof(DefLine), s->dlb->free, fp);
}



void term_body_bank_load(SType *s, FILE *fp)
{
  s->dlb = (DefLineBank *)malloc(sizeof(DefLineBank));
  if( s->dlb == NULL )
    error(MALLOC_FAILED,"term_body_bank_load 1");
  fscanf(fp,"%d %d\n", &s->dlb->max, &s->dlb->free);
  s->dlb->dline = (DefLine *)malloc(sizeof(DefLine) * s->dlb->max);
  if( s->dlb->dline == NULL )
    error(MALLOC_FAILED,"term_body_bank_load 2");
  fread(s->dlb->dline, sizeof(DefLine), s->dlb->free, fp);
}


void term_body_bank_strip(SType *s)
{
  s->dlb->max = s->dlb->free + 1;
}




// -------------------------------------------------------------------

void sem_c_bank_open(SType *s, int size)
{
  s->scb = (SemCBank *)malloc(sizeof(SemCBank));
  if( s->scb == NULL )
    error(MALLOC_FAILED,"sem_c_bank_open 1");
  s->scb->semc = (SemConst *)malloc(sizeof(SemConst) * size);
  if( s->scb->semc == NULL )
    error(MALLOC_FAILED,"sem_c_bank_open 2");
  s->scb->max = size;
  s->scb->free = 0;
}


void sem_c_bank_clear(SType *s)
{
  s->scb->free = 0;
}



void sem_c_bank_close(SType *s)
{
  free(s->scb->semc);
  free(s->scb);
  s->scb = NULL;
}


void sem_c_bank_dump(SType *s, FILE *fp)
{
  int i;

  fprintf(fp, "SemCBank (max = %d)\n", s->scb->max);
  for( i = 0 ; i < s->scb->free ; i += 1 ){
    fprintf(fp,"s%d:[%s,", i, string_bank_ref(s->sb, s->scb->semc[i].cat));
    switch(s->scb->semc[i].sign){
    case POS:
      fprintf(fp,"+,");
      break;
    case NEG:
      fprintf(fp,"-,");
      break;
    }
    switch(s->scb->semc[i].type){
    case VAL:
      fprintf(fp,"VAL,%s]\n",string_bank_ref(s->sb,s->scb->semc[i].val));
      break;
    case ASTR:
      fprintf(fp,"ASTR,*]\n");
      break;
    case STDSV:
      fprintf(fp,"STDSV,%s]\n",string_bank_ref(s->sb,s->scb->semc[i].val));
      break;
    case RAWSV:
      fprintf(fp,"RAWSV,%s]\n",string_bank_ref(s->sb,s->scb->semc[i].val));
      break;
    }
  }
}


void sem_c_bank_save(SType *s, FILE *fp)
{
  fprintf(fp,"%d %d\n", s->scb->max, s->scb->free);
  fwrite(s->scb->semc, sizeof(SemConst), s->scb->free, fp);
}


void sem_c_bank_load(SType *s, FILE *fp)
{
  s->scb = (SemCBank *)malloc(sizeof(SemCBank));
  if( s->scb == NULL )
    error(MALLOC_FAILED,"sem_c_bank_load 1");
  fscanf(fp,"%d %d\n", &s->scb->max, &s->scb->free);
  s->scb->semc = (SemConst *)malloc(sizeof(SemConst) * s->scb->max);
  if( s->scb->semc == NULL )
    error(MALLOC_FAILED,"sem_c_bank_load 2");
  fread(s->scb->semc, sizeof(SemConst), s->scb->free, fp);
}


void sem_c_bank_strip(SType *s)
{
  s->scb->max = s->scb->free + 1;
}



// ===================================================================


int parse_SCVAL(SType *s, int p, int *ans)
{
  int sum, len, len1, len2;

  if( (sum = scan_NUMALPHAS(stypeblock, p)) > 0 ){
    s->scb->semc[s->scb->free].type = VAL;
    s->scb->semc[s->scb->free].val = string_bank_add_n(s->sb, &stypeblock[p], sum);
    *ans = sum;
    return 1;
  }

  if( (sum = scan_ASTERISK(stypeblock, p)) > 0 ){
    s->scb->semc[s->scb->free].type = ASTR;
    *ans = sum;
    return 1;
  }

  if( (len1 = scan_DQ(stypeblock, p)) > 0 ){
    if( (len = scan_SQ(stypeblock, p + len1)) > 0 ){
      len1 += len;
      if( (len2 = scan_EUCS(stypeblock, p + len1)) > 0 ){
	sum = len1 + len2;
	if( (len = scan_SQ(stypeblock, p + sum)) > 0 ){
	  sum += len;
	  if( (len = scan_DQ(stypeblock, p + sum)) > 0 ){
	    s->scb->semc[s->scb->free].type = STDSV;
	    s->scb->semc[s->scb->free].val = string_bank_add_n(s->sb, &stypeblock[p+len1], len2);
	    *ans = sum + len;
	    return 1;
	  }
	}
      }
    } else if( (len2 = scan_EUCS(stypeblock, p + len1)) > 0 ){
      sum = len1 + len2;
      if( (len = scan_DQ(stypeblock, p + sum)) > 0 ){
	s->scb->semc[s->scb->free].type = RAWSV;
	s->scb->semc[s->scb->free].val = string_bank_add_n(s->sb, &stypeblock[p+len1], len2);
	*ans = sum + len;
	return 1;
      }
    }
  }

  *ans = 0;
  return -1;
}



int parse_SCCAT(SType *s, int p, int *ans)
{
  int sum, len;

  if( (sum = scan_LALPHA(stypeblock, p)) > 0 )
    if( (len = scan_LALPHA(stypeblock, p + sum)) > 0 ){
      sum += len;
      if( (len = scan_COLON(stypeblock, p + sum)) > 0 ){
	s->scb->semc[s->scb->free].cat = string_bank_add_n(s->sb, &stypeblock[p], sum);
	*ans = sum + len;
	return 1;
      }
    }
  *ans = 0;
  return -1;
}



int parse_SCCATVAL(SType *s, int p, int *ans)
{
  int sum, len;

  if( parse_SCCAT(s, p, &sum) >= 0 )
    if( parse_SCVAL(s, p + sum, &len) >= 0 ){
      *ans = sum + len;
      return 1;
    }
  *ans = 0;
  return -1;
}



// ֤ͤϡ̣°θĿ
int parse_POSSVALS(SType *s, int p, int *ans)
{
  int sum, len, num, len1, len2;
  enum {FALSE,TRUE} flag;
  
  num = 0;
  if( parse_SCCATVAL(s, p, &len) >= 0 ){
    if( s->scb->free >= s->scb->max )
      error(OVER_FLOWED,"parse_POSSVALS");
    s->scb->semc[s->scb->free].sign = POS;
    s->scb->free += 1;
    num += 1;
    sum = len;
    flag = TRUE;
    while(flag == TRUE){
      if( (len1 = scan_COMMA(stypeblock, p + sum)) > 0 )
	if( (parse_SCCATVAL(s, p + sum + len1, &len2)) >= 0 ){
	  if( s->scb->free >= s->scb->max )
	    error(OVER_FLOWED,"parse_POSSVALS");
	  s->scb->semc[s->scb->free].sign = POS;
	  s->scb->free += 1;
	  num += 1;
	  sum += len1 + len2;
	  continue;
	}
      flag = FALSE;
    }
    *ans = sum;
    return num;
  }

  *ans = 0;
  return 0;
}




// ֤ͤϡ̣°θĿ
int parse_NEGSVALS(SType *s, int p, int *ans)
{
  int sum, len, num, len1, len2, len3;
  enum {FALSE,TRUE} flag;

  num = 0;
  if( (sum = scan_MINUS(stypeblock, p)) > 0 )
    if( parse_SCCATVAL(s, p + sum, &len) >= 0 ){
      sum += len;
      if( (len = scan_COMMA(stypeblock, p + sum)) > 0 ){
	sum += len;
	if( s->scb->free >= s->scb->max )
	  error(OVER_FLOWED,"parse_NEGSVALS");
	s->scb->semc[s->scb->free].sign = NEG;
	s->scb->free += 1;
	num += 1;

	flag = TRUE;
	while(flag == TRUE){
	  if( (len1 = scan_MINUS(stypeblock, p + sum)) > 0 )
	    if( parse_SCCATVAL(s, p + sum + len1, &len2) >= 0 )
	      if( (len3 = scan_COMMA(stypeblock, p + sum + len1 + len2)) > 0 ){
		if( s->scb->free >= s->scb->max )
		  error(OVER_FLOWED,"parse_NEGSVALS");
		s->scb->semc[s->scb->free].sign = NEG;
		s->scb->free += 1;
		num += 1;
		sum += len1 + len2 + len3;
		continue;
	      }
	  flag = FALSE;
	}
	*ans = sum;
	return num;
      }
    }
  *ans = 0;
  return 0;
}


int parse_SCOND(SType *s, int p, int *ans)
{
  int sum, len, num1, num2;

  s->dlb->dline[s->dlb->free].scidx = s->scb->free;
  if( (len = scan_ML(stypeblock, p)) > 0 ){
    sum = len;
    num1 = 0;
    num2 = 0;
    if( (num1 = parse_NEGSVALS(s, p + sum, &len)) > 0 ){
      sum += len;
      fprintf(stderr,"%s\n", &stypeblock[p + sum]);
      fflush(stderr);
    }
    if( (num2 = parse_POSSVALS(s, p + sum, &len)) > 0 ){
      sum += len;
      if( (len = scan_MR(stypeblock, p + sum)) > 0 ){
	s->dlb->dline[s->dlb->free].sctype = EX;
	s->dlb->dline[s->dlb->free].scnum = num1 + num2;
	*ans = sum + len;
	return 1;
      }
    }
  }

  s->scb->free = s->dlb->dline[s->dlb->free].scidx;
  *ans = 0;
  return -1;
}


int parse_PCOND(SType *s, int p, int *ans)
{
  int sum, len;

  if( (len = scan_PL(stypeblock, p)) > 0 ){
    sum = len;
    if( (len = scan_NUMALPHADOT(stypeblock,p + sum)) > 0 ){
      s->dlb->dline[s->dlb->free].pc[0] = stypeblock[p + sum];
      sum += len;
      if( (len = scan_NUMALPHADOT(stypeblock,p + sum)) > 0 ){
	s->dlb->dline[s->dlb->free].pc[1] = stypeblock[p + sum];
	sum += len;
	if( (len = scan_NUMALPHADOT(stypeblock,p + sum)) > 0 ){
	  s->dlb->dline[s->dlb->free].pc[2] = stypeblock[p + sum];
	  sum += len;
	  if( (len = scan_NUMALPHADOT(stypeblock,p + sum)) > 0 ){
	    s->dlb->dline[s->dlb->free].pc[3] = stypeblock[p + sum];
	    sum += len;
	    if( (len = scan_PR(stypeblock, p + sum)) > 0 ){
	      s->dlb->dline[s->dlb->free].pctype = EX;
	      *ans = sum + len;
	      return 1;
	    }
	  }
	}
      }
    }
  }
  *ans = 0;
  return -1;
}



int parse_LCOND(SType *s, int p, int *ans)
{
  int sum, len1, len2, len3;

  if( (len1 = scan_EUCS(stypeblock, p)) > 0 ){
    s->dlb->dline[s->dlb->free].lctype = RAWLC;
    s->dlb->dline[s->dlb->free].lcstr = string_bank_add_n(s->sb, &stypeblock[p], len1);
    *ans = len1;
    return 1;
  }

  if( (len1 = scan_SQ(stypeblock, p)) > 0 ){
    sum = len1;
    if( (len2 = scan_EUCS(stypeblock, p + sum)) > 0 ){
      sum += len2;
      if( (len3 = scan_SQ(stypeblock, p + sum)) > 0 ){
	s->dlb->dline[s->dlb->free].lctype = STDLC;
	s->dlb->dline[s->dlb->free].lcstr = string_bank_add_n(s->sb,&stypeblock[p+len1],len2);
	*ans = sum + len3;
	return 1;
      }
    }
  }

  *ans = 0;
  return -1;
}




int parse_DLINE(SType *s, int p, int *ans)
{
  int sum, len;

  s->dlb->dline[s->dlb->free].lctype = NOLC;
  s->dlb->dline[s->dlb->free].pctype = NO;
  s->dlb->dline[s->dlb->free].sctype = NO;

  if( (sum = scan_PHI(stypeblock, p)) > 0 ){
    s->dlb->dline[s->dlb->free].lctype = PHILC;
    s->dlb->dline[s->dlb->free].lcstr = string_bank_add_n(s->sb, &stypeblock[p], sum);
    *ans = sum;
    return 1;
  }

  if( parse_LCOND(s, p, &sum) >= 0 ){
    if( parse_PCOND(s, p + sum, &len) >= 0 )
      sum += len;
    if( parse_SCOND(s, p + sum, &len) >= 0 )
      sum += len;
    *ans = sum;
    return 1;
  }

  if( parse_PCOND(s, p, &sum) >= 0 ){
    if( parse_SCOND(s, p + sum, &len) >= 0 )
      sum += len;
    *ans = sum;
    return 1;
  }

  *ans = 0;
  return -1;
}




int parse_END(SType *s, int p, int *ans)
{
  int sum, len;

  if( (sum = scan_END(stypeblock, p)) > 0 ){
    if( (len = scan_RET(stypeblock, p + sum)) > 0 ){
      *ans = sum + len;
      return 1;
    }
  }
  *ans = 0;
  return -1;
}



int parse_POSITIVE(SType *s, int p, int *ans)
{
  int sum, len;

  if( s->dlb->free >= s->dlb->max )
    error(OVER_FLOWED,"parse_POSITIVE");
  if( parse_DLINE(s, p, &len) >= 0 ){
    sum = len;
    if( (len = scan_RET(stypeblock, p + sum)) > 0){
      s->dlb->dline[s->dlb->free].sign = POS;
      *ans = sum + len;
      return s->dlb->free++;
    }
  }
  *ans = 0;
  return -1;
}




int parse_NEGATIVE(SType *s, int p, int *ans)
{
  int sum, len;

  if( s->dlb->free >= s->dlb->max )
    error(OVER_FLOWED,"parse_NEGATIVE");
  if( (len = scan_MINUS(stypeblock, p)) > 0 ){
    sum = len;
    if( parse_DLINE(s, p + sum, &len) >= 0 ){
      sum += len;
      if( (len = scan_RET(stypeblock, p + sum)) > 0){
	s->dlb->dline[s->dlb->free].sign = NEG;
	*ans = sum + len;
	return s->dlb->free++;
      }
    }
  }
  *ans = 0;
  return -1;
}



// ֤ͤ StringBank Υǥå
// ʸβϤǼԤȤStringBank ̵̤ˤʤ뤬̵
int parse_NAME(SType *s, int p, int *ans)
{
  int sum, len, str;

  if( (sum = scan_LALPHAS(stypeblock, p)) > 0 )
    if( (len = scan_RET(stypeblock, p + sum)) > 0 ){
      str = string_bank_add_n(s->sb, &stypeblock[p], sum);
      *ans = sum + len;
      return str;
    }
  if( (sum = scan_DOT(stypeblock, p)) > 0 ){
    if( (len = scan_SHARP(stypeblock, p + sum)) > 0 )
      sum += len;
    if( (len = scan_SALPHAS(stypeblock, p + sum)) > 0 ){
      sum += len;
      if( (len = scan_RET(stypeblock, p + sum)) > 0 ){
	str = string_bank_add_n(s->sb, &stypeblock[p], sum);
	*ans = sum + len;
	return str;
      }
    }
  }
  if( (sum = scan_HAT(stypeblock, p)) > 0 )
    if( (len = scan_SALPHAS(stypeblock, p + sum)) > 0 ){
      sum += len;
      if( (len = scan_RET(stypeblock, p + sum)) > 0 ){
	str = string_bank_add_n(s->sb, &stypeblock[p], sum);
	*ans = sum + len;
	return str;
      }
    }

  *ans = 0;
  return -1;
}


// p  stypeblockΰ֤֡ͤ PreTermBank Υǥå
int parse_BLOCK(SType *s, int p, int *ans)
{
  int sum, len;

  if( s->ptb->free >= s->ptb->max )
    error(OVER_FLOWED,"parse_BLOCK 1");
  if( (s->ptb->preterm[s->ptb->free].name = parse_NAME(s, p, &len)) >= 0 ){
    s->ptb->preterm[s->ptb->free].dl = s->dlb->free;
    s->ptb->preterm[s->ptb->free].dl_num = 0;
    sum = len;
    while( parse_NEGATIVE(s, p + sum, &len) >= 0 ){
      s->ptb->preterm[s->ptb->free].dl_num += 1;
      sum += len;
    }
    if( parse_POSITIVE(s, p + sum, &len) >= 0 ){
      s->ptb->preterm[s->ptb->free].dl_num += 1;
      sum += len;
      while( parse_POSITIVE(s, p + sum, &len) >= 0 ){
	s->ptb->preterm[s->ptb->free].dl_num += 1;
	sum += len;
      }
      if( parse_END(s, p + sum, &len) >= 0 ){
	*ans = sum + len;
	return s->ptb->free++;
      }
    }    
  }
  *ans = 0;
  return -1;
}

// ===================================================================

// ȡκ
void comcut_spccut(char *line)
{
  int i,j;
  char *p;

  // Ȥ
  for( i = 0; line[i] != ';' && line[i] != '\0' ; i += 1 ){}
  line[i] = '\0';
  for( i -= 1; i > 0 && (line[i] == '\t' || line[i] == ' ') ; i -= 1 ) {}
  i += 1;
  line[i] = '\0';

  // ڡκ
  for( p = line, j = 0; j < i; j += 1 ){
    if( line[j] != ' ' && line[j] != '\t' )
      *p++ = line[j];
  }
  *p = '\0';
}


// ===================================================================
// SǼ

SType *stype_open(int preterm, int dline, int attr)
{
  SType *s;
  s = (SType *)malloc(sizeof(SType));
  if( s == NULL )
    error(MALLOC_FAILED,"stype_open");
  preterm_bank_open(s, preterm);
  term_body_bank_open(s, dline);
  sem_c_bank_open(s, attr);
  return s;
}

// -------------------------------------------------------------------
// SƤõʥ곫Ϥʤ

void stype_clear(SType *s)
{
  preterm_bank_clear(s);
  term_body_bank_clear(s);
  sem_c_bank_clear(s);
}


// -------------------------------------------------------------------
// SΥ곫

void stype_close(SType *s)
{
  preterm_bank_close(s);
  term_body_bank_close(s);
  sem_c_bank_close(s);
}


// -------------------------------------------------------------------
// SΥ

void stype_dump(SType *s, FILE *fp)
{
  preterm_bank_dump(s, fp);
  term_body_bank_dump(s, fp);
  sem_c_bank_dump(s, fp);
  string_bank_dump(s->sb, fp);
}


// -------------------------------------------------------------------
// SΥ

void stype_save(SType *s, FILE *fp)
{
  preterm_bank_save(s, fp);
  term_body_bank_save(s, fp);
  sem_c_bank_save(s, fp);
  string_bank_save(s->sb, fp);
}


// -------------------------------------------------------------------
// SޥåפΥ

SType *stype_load(FILE *fp)
{
  SType *s;

  s = (SType *)malloc(sizeof(SType));
  if( s == NULL )
    error(MALLOC_FAILED, "stype_load");
  preterm_bank_load(s, fp);
  term_body_bank_load(s, fp);
  sem_c_bank_load(s, fp);
  s->sb = string_bank_load(fp);
  return s;
}


// -------------------------------------------------------------------
// Max Ǿ¤ˤ

void stype_strip(SType *s)
{
  preterm_bank_strip(s);
  term_body_bank_strip(s);
  sem_c_bank_strip(s);
}

// -------------------------------------------------------------------
// Sե뤫ɤ߹

void stype_convert(SType *s, FILE *fp)
{
  char line[MAX_LINE];
  enum {NAME,DLINE} mode;
  int len;

  mode = NAME;
  while( fgets(line,MAX_LINE,fp) != NULL ){
    comcut_spccut(line);
    if( line[0] == '\n' )	       // ԡȤΤߤιԤΥå
      continue;

    switch(mode){
    case NAME:
      stypeblock[0] = '\0';
      strcat(stypeblock, line);
      mode = DLINE;
      break;
    case DLINE:
      strcat(stypeblock, line);
      if( scan_END(line, 0) > 0 ){		  // endԤΤȤ
	if( parse_BLOCK(s, 0,&len) < 0 )		  // ϤƳǼ
	  error(SYNTAX_ERROR, stypeblock);  // ϥ顼
	mode = NAME;
      }
      break;
    }
  }
}
