#ifndef __TRIE_H__
#define __TRIE_H__

typedef struct {
  int next[26];
  int num;
} TrieC26Node;

typedef struct {
  TrieC26Node *node;
  int max;
  int free;
  char base;
} TrieC26;

TrieC26 *trie_c26_open(int, char);
void trie_c26_clear(TrieC26 *);
void trie_c26_close(TrieC26 *);
void trie_c26_entry(TrieC26 *, char *, int);
void trie_c26_entry_n(TrieC26 *, char *, int, int);
int trie_c26_lookup(TrieC26 *, char *);
int trie_c26_lookup_n(TrieC26 *, char *, int);
void trie_c26_dump(TrieC26 *, FILE *);



typedef struct {
  int next[94];
  int num;
} TrieC94Node;

typedef struct {
  TrieC94Node *node;
  int max;
  int free;
  char base;
} TrieC94;

TrieC94 *trie_c94_open(int, char);
void trie_c94_clear(TrieC94 *);
void trie_c94_close(TrieC94 *);
void trie_c94_entry(TrieC94 *, char *, int);
void trie_c94_entry_n(TrieC94 *, char *, int, int);
int trie_c94_lookup(TrieC94 *, char *);
int trie_c94_lookup_n(TrieC94 *, char *, int);
void trie_c94_dump(TrieC94 *, FILE *);

#endif
