/* walker10.c */

#include <stdio.h>
#include <time.h>

#include "inmorph.h"
#include "atype.h"
#include "stype.h"
#include "map_linker.h"
#include "agent.h"
#include "numstack.h"
#include "error.h"
#include "cnd_checker.h"
#include "core_checker.h"
#include "asmemory.h"

//                    int ξ 2,147,483,647

#define MAX_MORPH_BLOCK 100000  // ǥǡγǼ 1000ʸ/ * 100
#define MAX_MORPH_LINE  100
#define MAX_MORPH_POS   500     // ʿ 5 / * 100
#define MAX_MORPH_ATTR  5000    // ʿ 10 /POS * 500 POS

#define MAX_MORPH_BIND_LINE 10000000  // ŬθĿ
#define MAX_MORPH_BIND_POS   1000000  // 
#define MAX_MORPH_BIND_ATTR  1000000  // 


#define MAX_STOR	10000	// SΥޥåĿ
#define MAX_STOR_PBIT	10000	// ʻ쥳ɥӥåȤε
#define MAX_STOR_ATTR	100000	// ̣°ε

#define MAX_AGENTS	100000	// Ȥ - 1

// ==================================================================
// Хѿ

char *pname;	// ʸѥID
int chknum, skpnum; // ɬܻ̤ѥȾȹ祹åפ򤷤

// ===================================================================
// 塼˥󥰤Υݥȡagent.h γĥؿƤ

#define node_count_arc(_am,_node)\
	((_am)->amap->bnb->bgnode[(_node)].num)

#define node_first_arc(_am,_node)\
	node_nth_arc(_am,_node,0)

#define node_nth_arc(_am,_node,_n)\
	((_am)->amap->bnb->bgnode[(_node)].index_of_arc + (_n))


// ==================================================================
// إפɽ

void show_help()
{
  fprintf(stderr,"walker10 <smap> <amap> <pmap> <com> [<arg>]\n");
  fprintf(stderr," <command>  <arg>\n");
  fprintf(stderr,"   -self      <ǥ쥯ȥ>\n");
  fprintf(stderr,"   -cross     <ꥹȥե>\n");
  fprintf(stderr,"   -all       <ꥹȥե>\n");
  fprintf(stderr,"   -int\n");
  exit(1);
}


// ==================================================================
// 

AsMemory *analyse_arguments(int argc, char *argv[])
{
  AsMemory *asom;

  asom = asmemory_new(2048,10);
  if( argc < 5 ){
    as_set(asom,"help","T");
    return asom;
  }

  as_set(asom,"smap",argv[1]);
  as_set(asom,"amap",argv[2]);
  as_set(asom,"pmap",argv[3]);
  as_set(asom,argv[4],"T");
  if( argc > 5 )
    as_set(asom,"arg1",argv[5]);
  if( argc > 6 )
    as_set(asom,"arg2",argv[6]);

  return asom;
}


// ==================================================================
// ե뤪ӥѥեΥ

void walker_load_sentence_pattern_dictionary(AgentManager *am, AsMemory *opt)
{
  FILE *fp;
  SType *st;
  AType *at, *pt;

  // SޥåפΥ ----------------------------------------
  fp = fopen(as_get(opt,"smap"), "r");
  if( fp == NULL )
    error(NO_FILE_OR_DIRECTORY, as_get(opt,"smap"));
  st = stype_load(fp);
  fclose(fp);

  // AޥåפΥ ----------------------------------------
  fp = fopen(as_get(opt,"amap"),"r");
  if( fp == NULL )
    error(NO_FILE_OR_DIRECTORY, as_get(opt,"amap"));
  at = atype_load(fp);
  fclose(fp);

  // ѥΥޥåפΥ ----------------------------------------
  fp = fopen(as_get(opt,"pmap"),"r");
  if( fp == NULL )
    error(NO_FILE_OR_DIRECTORY, as_get(opt,"pmap"));
  pt = atype_load(fp);
  fclose(fp);
  am->num_of_pattern = pt->nb->free;

  // ޥåפΥ -----------------------------------------------
  map_linker(st, at, pt);

  agent_manager_map(am, st, pt);
}

// ==================================================================
// ǥեΥ
void walker_load_inmorph(AgentManager *am, char *filename)
{
  FILE *fp;
  InMorph *im;

  fp = fopen(filename,"r");
  if( fp == NULL )
    error(NO_FILE_OR_DIRECTORY, filename);
  im = inmorph_open(MAX_MORPH_BLOCK,
	MAX_MORPH_LINE, MAX_MORPH_POS, MAX_MORPH_ATTR,
	MAX_MORPH_BIND_LINE, MAX_MORPH_BIND_POS, MAX_MORPH_BIND_ATTR);
  inmorph_load(im, fp);

  inmorph_set_eucbitmap(im, am->imbitmap);

  agent_manager_morph(am, im);

  fclose(fp);
}


// ==================================================================
// ʤ߷

int pretest(AgentManager *am, int ptn_idx)
{
  Network *n;
  n = &am->amap->nb->network[ptn_idx];
  if( eucmap_check_bitmap_including(am->imbitmap, am->amap->epb, n->letter_condition, n->lc_num) ){
    chknum += 1;
    return 1;
  } else {
    skpnum += 1;
    return 0;
  }
}



// ===================================================================
// 1ĤΥѥȤξȹ

#define swap(_a,_b,_t) (_t)=(_a);(_a)=(_b);(_b)=(_t)


void match_one_pattern(AgentManager *am, int ptn_idx)
{
  NumStack *dmylist;
  int ref, i, agt_idx, chld_idx, num;
  Agent *agt;
#ifdef _TEST_AGENT_STATE_
  Agent *chld;
  int j;
#endif
#ifdef _TEST_NUMBER_
  int cnt;
  int num_ad1, num_ad2_3, num_ad4le;
  int num_sd1, num_sd2_3, num_sd4le;
#endif


  ref = -1;
  while( 1 ){
    // ʸλȰ֤ư
    if( !inmorph_continue( am->im, ref ) )
      return; // ʸνޤǤ餪ޤ
    ref += 1;
#ifdef _TEST_INPUT_SENTENCE_
    fprintf(stdout,"==================================================\n");
    inmorph_print_easily(am->im, ref, stdout);
#endif

    // Ȥ򵯤
    while( !numstack_empty( am->slplist ) ){
      agt_idx = numstack_pop( am->slplist );
      agt = agent_pointer( am, agt_idx );
      if( agt->awake_time == ref ){
	agt->hp = DEFAULT_HP;
	agt->mode = FULLMODE;
	numstack_push( am->actlist, agt_idx );
      } else {
	numstack_push( am->tmplist, agt_idx );
      }
    }
    swap( am->slplist, am->tmplist, dmylist );

    // ȤΤ롣
#ifdef _TEST_NUMBER_    
    num_ad1 = 0;
    num_ad2_3 = 0;
    num_ad4le = 0;
    for( cnt = 0; cnt < am->actlist->sp; cnt += 1 ){
      agt_idx = am->actlist->stack[cnt];
      agt = agent_pointer( am, agt_idx );
      if( agt->depth == 1 )
	num_ad1 += 1;
      else if( agt->depth == 2 || agt->depth == 3 )
	num_ad2_3 += 1;
      else if( agt->depth > 3 )
	num_ad4le += 1;
    }
    num_sd1 = 0;
    num_sd2_3 = 0;
    num_sd4le = 0;
    for( cnt = 0; cnt < am->slplist->sp; cnt += 1 ){
      agt_idx = am->slplist->stack[cnt];
      agt = agent_pointer( am, agt_idx );
      if( agt->depth == 1 )
	num_sd1 += 1;
      else if( agt->depth == 2 || agt->depth == 3 )
	num_sd2_3 += 1;
      else if( agt->depth > 3 )
	num_sd4le += 1;
    }
    printf("ȯȿ:%d     ¸ȿ:%d\n",am->last_name,num_ad1+num_ad2_3+num_ad4le+num_sd1+num_sd2_3+num_sd4le);
    printf("                 depth 1   depth 2-3   depth 4-\n");
    printf("  active agents:   %3d       %3d         %3d\n",num_ad1, num_ad2_3, num_ad4le);
    printf("  sleeping agents: %3d       %3d         %3d\n",num_sd1, num_sd2_3, num_sd4le);
#endif

    /* << walker6,7,8 ǤϹΤ̤ >>
     * rest = actlist;
     * while( rest != null ){
     * agt = car( actlist );
     * rest = cdr( actlist );
     * rest = join_agent( agt, rest );
     * actlist << agt;
     */

#ifdef _TEST_AGENT_STATE_
    fprintf(stdout,"--------------------------------------------------\n");
#endif
  ACTIVATE_AGENTS:
#ifdef _TEST_AGENT_STATE_
    printf("active: ");
    for( j = 0; j < am->actlist->sp; j += 1 ){
      agt = agent_pointer( am, am->actlist->stack[j] );
      printf(" agt%d ",agt->name);
    }
    printf("\nsleeping: ");
    for( j = 0; j < am->slplist->sp; j += 1 ){
      agt = agent_pointer( am, am->slplist->stack[j] );
      printf(" agt%d ",agt->name);
    }
    printf("\n");
#endif
    // ưΥȤư
    // եʹ
    while( !numstack_empty( am->actlist ) ){
      agt_idx = numstack_pop( am->actlist );
      agt = agent_pointer( am, agt_idx );

#ifdef _TEST_AGENT_STATE_
      agent_print_detail(am, agt_idx, stdout);
#endif

      if( agt->loc_type == LOC_ARC ){
#ifdef _TEST_AGENT_STATE_
	fprintf(stdout,"on arc action... agent%d\n",agt->name); 
#endif
	across_arc( am, agt_idx, ref, agt->loc_idx );
	numstack_push(am->tmplist, agt_idx);
      } else { // LOC_NODE
#ifdef _TEST_AGENT_STATE_
	fprintf(stdout,"on node action... agent%d\n",agt->name);
#endif      
	num = node_count_arc( am, agt->loc_idx ) - 1;
#ifdef _TEST_AGENT_STATE_
	fprintf(stdout,":%d\n",num + 1);
	for( j = 0 ; j <= num ; j += 1 ){
	  fprintf(stdout,"  ");
	  cnd_bank_print_one(am->amap, node_nth_arc( am, agt->loc_idx, j), stdout);
	}
#endif
	for( i = 0 ; i < num; i += 1 ){
	  chld_idx = agent_breed( am, agt_idx );
#ifdef _TEST_AGENT_STATE_
	  chld = agent_pointer( am, chld_idx );
	  fprintf(stdout,"on arc action... agent%d\n",chld->name); 
	  fprintf(stdout,"   --> c%d\n", node_nth_arc( am, agt->loc_idx, i ));
#endif
	  across_arc( am, chld_idx, ref, node_nth_arc( am, agt->loc_idx, i ) );
	  numstack_push( am->tmplist, chld_idx );
	}
#ifdef _TEST_AGENT_STATE_
	fprintf(stdout,"on arc action... agent%d\n",agt->name); 
	fprintf(stdout,"   --> c%d\n", node_nth_arc( am, agt->loc_idx, num ));
#endif
	across_arc( am, agt_idx, ref, node_nth_arc( am, agt->loc_idx, num ) );
	numstack_push( am->tmplist, agt_idx );
      }
    } // λǡactlist ϶

#ifdef _TEST_AGENT_STATE_
    fprintf(stdout,"- - - - - - - - - - - - - - - - - - - - - - - - - \n");
#endif
    // Ȥγưξ֥å
    while( !numstack_empty( am->tmplist ) ){
      agt_idx = numstack_pop( am->tmplist );
      agt = agent_pointer( am, agt_idx );
      switch( agt->mode ){
      case HELLMODE:
	agent_kill( am, agt_idx );
	break;
      case HEAVENMODE:
	numstack_push( am->angellist, agt_idx );
	break;
      case SLEEPMODE:
	numstack_push( am->slplist, agt_idx );
	break;
      case HALFMODE:
	if( agt->depth == 1 ){
	  agt->mode = SLEEPMODE;
	  numstack_push( am->slplist, agt_idx);
	} else {
	  numstack_push( am->actlist, agt_idx );
	}
	break;
      case FULLMODE:
	numstack_push( am->actlist, agt_idx );
      }
    } // λ, tmplist ϶

    // ưΥȤСư³롣
    if( !numstack_empty( am->actlist ) )
      goto ACTIVATE_AGENTS;

    // ư̵ٷ̵ʤСȹ罪λ
    if( numstack_empty( am->slplist ) )
      return; // λ
  }
}


// ==================================================================


void walker_inmorph_input_face(AgentManager *am, FILE *fp)
{
  inmorph_clear(am->im);
  inmorph_load(am->im, fp);
  inmorph_set_eucbitmap(am->im, am->imbitmap);
}


void walker_one_pattern_matching_face(AgentManager *am, int p_indx)
{
  int agt_indx, node_indx;
  Agent *agt;

  agent_manager_clear( am );
  if( !pretest( am, p_indx ) )
    return;
  agt_indx = agent_new(am);
  agt = agent_pointer(am, agt_indx);
  node_indx = pattern_first_node(am, p_indx);
  agent_move_to_node(agt, node_indx);
  numstack_push(am->actlist, agt_indx);
  match_one_pattern(am, p_indx);
}


void walker_self_pattern_matching(AgentManager *am, AsMemory *option)
{
  char filename[BUFSIZ], *pid;
  int baselen, pnum;
  Network *net;
  FILE *fp;


  strcat(filename, as_get(option, "arg"));
  baselen = strlen(filename);
  if( filename[baselen - 1] != '/' ){
    filename[baselen++] = '/';
    filename[baselen] = '\0';
  }
  filename[baselen+2 ] = '/';
  filename[baselen+6 ] = '/';
  filename[baselen+13] = '.';
  filename[baselen+14] = 'm';
  filename[baselen+15] = 'r';
  filename[baselen+16] = 'p';
  filename[baselen+18] = 'r';
  filename[baselen+19] = 's';
  filename[baselen+20] = 'l';
  filename[baselen+21] = 't';
  filename[baselen+22] = '\0';

  for( pnum = 0; pnum < am->num_of_pattern; pnum += 1 ){
    net = &am->amap->nb->network[pnum];
    pid = string_bank_ref(am->amap->sb, net->name);
    filename[baselen   ] = pid[0];
    filename[baselen+1 ] = pid[1];
    filename[baselen+3 ] = pid[2];
    filename[baselen+4 ] = pid[3];
    filename[baselen+5 ] = pid[4];
    filename[baselen+7 ] = pid[5];
    filename[baselen+8 ] = pid[6];
    filename[baselen+9 ] = pid[7];
    filename[baselen+10] = pid[8];
    filename[baselen+11] = pid[9];
    filename[baselen+12] = pid[10];
    filename[baselen+17] = '\0';
    fp = fopen(filename,"r");
    agent_manager_clear(am);
    if( fp != NULL ){
      walker_inmorph_input_face(am, fp);
      fclose(fp);
      walker_one_pattern_matching_face(am, pnum);
    }
    filename[baselen+17] = '.'; // ե̾֡.mrp.rsltפѲ
    fp = fopen(filename,"a");
    if( fp == NULL )
      error(UNKNOWN,"file write open error");
    if( !numstack_empty(am->angellist) )
      fprintf(fp, "%s\t%d\n", pid, numstack_size(am->angellist) );
    fclose(fp);
  }
}

void walker_cross_pattern_matching(AgentManager *am, AsMemory *option)
{
  char mrpfile[BUFSIZ], ex_pname[BUFSIZ], *p, *q, *pname;
  FILE *fp_list, *fp_mrp, *fout;
  int len, pnum, pname_indx;

  fp_list = fopen(as_get(option, "arg"),"r");
  if( fp_list == NULL )
    error(NO_FILE_OR_DIRECTORY,as_get(option,"arg"));
  while( fgets(mrpfile, BUFSIZ, fp_list) != NULL ){
    len = strlen(mrpfile);
    mrpfile[len-1] = '\0';	// ʸ̾

    fp_mrp = fopen(mrpfile,"r");
    if( fp_mrp != NULL ){
      // ʸν
      walker_inmorph_input_face( am, fp_mrp );
      fclose(fp_mrp);

      // ѥ̾
      p = mrpfile;
      while( *p++ != '/' ){}
      q = ex_pname;
      while( *p != '.' ){
	if( *p != '/' )
	  *q++ = *p;
	p += 1;
      }

      // ν
      strcat(mrpfile,".rslt");
      if( (fout = fopen(mrpfile,"w")) == NULL )
	error(UNKNOWN,"file write open error");

      // ȹΥᥤ롼
      for( pnum = 0; pnum < am->num_of_pattern; pnum += 1 ){
	pname_indx = am->amap->nb->network[pnum].name;
	pname = string_bank_ref(am->amap->sb,pname_indx);
	if( strcmp(pname, ex_pname) == 0 ){ // ѥΤȤ
	  do{ // Ϣ³뤳ȤΤǡ
	    pnum += 1;
	  } while( am->amap->nb->network[pnum].name == pname_indx );
	  break;
	} else {
	  walker_one_pattern_matching_face(am, pnum);
	  if( !numstack_empty(am->angellist) )
	    fprintf(fout,"%s\t%d\n", pname, numstack_size(am->angellist));
	}
      } // ѥIDǥȺѤߤƤ뤳ȤԤƤ롣
      for( ; pnum < am->num_of_pattern; pnum += 1 ){
	walker_one_pattern_matching_face(am, pnum);
	if( !numstack_empty(am->angellist) )
	  fprintf(fout,"%s\t%d\n", pname, numstack_size(am->angellist));
      }
      fclose(fout);
    } // ȹ罪λ
  }
  fclose(fp_list);
}



void walker_all_pattern_matching(AgentManager *am, AsMemory *option)
{
  char mrpfile[BUFSIZ], *pname;
  FILE *fp_list, *fp_mrp, *fout;
  int len, pnum, pname_indx;

  fp_list = fopen(as_get(option, "arg"),"r");
  if( fp_list == NULL )
    error(NO_FILE_OR_DIRECTORY,as_get(option,"arg"));
  while( fgets(mrpfile, BUFSIZ, fp_list) != NULL ){
    len = strlen(mrpfile);
    mrpfile[len-1] = '\0';	// ʸ̾

    fp_mrp = fopen(mrpfile,"r");
    if( fp_mrp != NULL ){
      // ʸν
      walker_inmorph_input_face( am, fp_mrp);
      fclose(fp_mrp);

      // ν
      strcat(mrpfile,".rslt");
      if( (fout = fopen(mrpfile,"w")) == NULL )
	error(UNKNOWN,"file write open error");

      // ȹΥᥤ롼
      for( pnum = 0; pnum < am->num_of_pattern; pnum += 1 ){
	walker_one_pattern_matching_face(am, pnum);
	if( !numstack_empty(am->angellist) ){
	  pname_indx = am->amap->nb->network[pnum].name;
	  pname = string_bank_ref(am->amap->sb,pname_indx);
	  fprintf(fout,"%s\t%d\n", pname, numstack_size(am->angellist));
	}
      }
      fclose(fout);
    } // ȹ罪λ
  }
  fclose(fp_list);
}



void walker_interactive_help()
{
  printf(" p..ȹ礹ѥID\n");
  printf(" a..ѥȾȹ\n");
  printf(" m..ȹ礹ǥե\n");
  printf(" i..ʸϤ\n");
  printf(" s..ȹ򳫻\n");
  printf(" q..λ\n");
}


void walker_interactive_pattern(char *line)
{
  static char buf[BUFSIZ];
  int len;

  printf("ѥID ꤷƤ AC000004-00\n");
  printf("> ");
  fflush(stdout);
  if( fgets(buf,BUFSIZ,stdin) == NULL ){
    printf("\n");
    return;
  }
  len = strlen(buf);
  if( buf[len-1] == '\n' )
    buf[len-1] = '\0';
  strcpy(line, buf);
}


void walker_interactive_morph(AgentManager *am, char *mrpfile)
{
  char buf[BUFSIZ];
  FILE *fp;
  int len;

  while( 1 ){
    printf("ǥե̾ꤷƤ test1.mrp\n");
    printf("> ");
    fflush(stdout);
    if( fgets(buf,BUFSIZ,stdin) == NULL ){
      printf("\n");
      return;
    }
    len = strlen(buf);
    if( buf[len-1] == '\n' )
      buf[len-1] = '\0';
    fp = fopen(buf,"r");
    if( fp == NULL ){
      printf("ե뤬ޤ\n");
      continue;
    }
    walker_inmorph_input_face(am,fp);
    fclose(fp);
    strcpy(mrpfile, buf);
    return;
  }
}


void walker_interactive_input_sentence(AgentManager *am, char *mrpfile)
{
  FILE *fp;
  char buf[BUFSIZ];

  fp = fopen("workfile.walker10.txt","w");
  if( fp == NULL )
    error(UNKNOWN,"can't open work file");
  printf("ʸ> ");
  fflush(stdout);
  if( fgets(buf,BUFSIZ,stdin) == NULL ){
    fclose(fp);
    printf("\n");
    return;
  }
  fprintf(fp,buf);
  fclose(fp);
  system("morph_alt workfile.walker10.txt | morph_bun | morph_imi > workfile.walker10.mrp");
  fp = fopen("workfile.walker10.mrp","r");
  walker_inmorph_input_face(am,fp);
  fclose(fp);
  strncpy(mrpfile, buf, 8);
}


void walker_interactive_search(AgentManager *am, char *pname, char *mrp)
{
  int flag, pnum, pname_indx;
  char *pname00;
  double so_time;
  clock_t clk;

  if( strcmp(mrp,"---") == 0 ){
    printf("input morph file\n");
  } else {   
    if( strcmp(pname,"all") == 0 ){
      flag = 0;
      clk = clock();
      for( pnum = 0; pnum < am->num_of_pattern; pnum += 1 ){
	walker_one_pattern_matching_face(am, pnum);
	if( !numstack_empty(am->angellist) ){
	  flag = 1;
	  pname_indx = am->amap->nb->network[pnum].name;
	  pname = string_bank_ref(am->amap->sb,pname_indx);
	  printf("match %s\t%d\n", pname, numstack_size(am->angellist));
	}
      }
      if( flag == 0 ) {
	printf("unmatch\n");
      }
      so_time = (clock()-clk) / (double)(CLOCKS_PER_SEC);
      printf("**[time=%.2lfs]\n", so_time);
    } else if( strcmp(pname,"---") == 0 ) {
      printf("input pattern id or 'all'\n");
    } else {
      for( pnum = 0; pnum < am->num_of_pattern; pnum += 1 ){
	pname_indx = am->amap->nb->network[pnum].name;
	pname00 = string_bank_ref(am->amap->sb,pname_indx);
	if( strcmp(pname, pname00) == 0 ){
	  walker_one_pattern_matching_face(am, pnum);
	  if( !numstack_empty(am->angellist) ){
	    printf("match %s\t%d\n", pname, numstack_size(am->angellist));
	  } else {
	    printf("unmatch %s\n",pname);
	  }
	}
      }
    }
  }
}



void walker_interactive_matching(AgentManager *am, AsMemory *option)
{
  char line[BUFSIZ], pname[BUFSIZ], mrpfile[BUFSIZ];
  int len;

  strcpy(pname,"all");
  strcpy(mrpfile,"---");
  
  fprintf(stdout,"SPM interactive mode\n");
  while( 1 ){
    fprintf(stdout,"PID:%s/MRP:%s> ", pname, mrpfile);
    fflush(stdout);
    if( fgets(line, BUFSIZ, stdin) == NULL ){
      printf("\n");
      break;
    }

    len = strlen(line);
    line[len-1] = '\0';

    if( ( strcmp(line,"?") == 0 ) ||
	( strcmp(line,"h") == 0 ) ){
      walker_interactive_help();
    } else if( (strcmp(line,"p") == 0) ){
      walker_interactive_pattern(pname);
    } else if( (strcmp(line,"a") == 0) ){
      strcpy(pname,"all");
    } else if( (strcmp(line,"m") == 0) ){
      walker_interactive_morph(am, mrpfile);
    } else if( (strcmp(line,"i") == 0) ){
      walker_interactive_input_sentence(am, mrpfile);
    } else if( (strcmp(line,"s") == 0) ){
      walker_interactive_search(am, pname, mrpfile);
    } else if( (strcmp(line,"q") == 0) )
      break;
  }
}

// ==================================================================

int main(int argc, char *argv[])
{
  AgentManager *am;
  AsMemory *option;
  int mode;

  // 
  option = analyse_arguments(argc, argv);

  if( as_get(option, "-self") != NULL )
    mode = 1;
  else if( as_get(option, "-cross") != NULL )
    mode = 2;
  else if( as_get(option, "-all") != NULL )
    mode = 3;
  else if( as_get(option, "-int") != NULL )
    mode = 4;
  else
    mode = 0;

  if( mode == 0 )
    show_help();

  // ȥޥ͡ν
  am = agent_manager_open(MAX_AGENTS);

  // ʸѥ󼭽񤪤եΥ
  printf("loading pattern dictionary\n");
  fflush(stdout);

  walker_load_sentence_pattern_dictionary(am, option);

  // ʸΥꥢγ
  agent_manager_morph(am, 
		      inmorph_open(MAX_MORPH_BLOCK,
				   MAX_MORPH_LINE,
				   MAX_MORPH_POS,
				   MAX_MORPH_ATTR,
				   MAX_MORPH_BIND_LINE,
				   MAX_MORPH_BIND_POS,
				   MAX_MORPH_BIND_ATTR) );

  switch( mode ){
  case 1:
    walker_self_pattern_matching(am, option);
    break;
  case 2:
    walker_cross_pattern_matching(am, option);
    break;
  case 3:
    walker_all_pattern_matching(am, option);
    break;
  case 4:
    walker_interactive_matching(am, option);
    break;
  }
  return 0;
}
